
#define RANKS78 0xffff000000000000
#define RANKS678 0xffffff0000000000
#define RANKS12 0x000000000000ffff
#define RANKS123 0x00000000000ffffff

#include "RobboLito.h"
#include "evaluation.v"

uint8 YakovWTM[24576] = {
#include "YakovChart.bi"
};

uint8 YakovBTM[24576] = {
#include "YakovChart.ne"
};

void
Mobility (typePOS *POSITION)
{
  uint64 U, A, T, AttB, AttR;
  int b;
  DYN->wXray = 0;
  DYN->bXray = 0;
  A = AttK[POSITION->wKsq];
  DYN->wAtt = A;
  if (A & bBitboardK)
    DYN->bKcheck = SqSet[POSITION->wKsq];
  else
    DYN->bKcheck = 0;
  A = AttK[POSITION->bKsq];
  DYN->Batt = A;
  if (A & wBitboardK)
    DYN->wKcheck = SqSet[POSITION->bKsq];
  else
    DYN->wKcheck = 0;
  for (U = wBitboardN; U; BitClear (b, U))
    {
      b = BSF (U);
      A = AttN[b];
      DYN->wAtt |= A;
      if (A & bBitboardK)
	DYN->bKcheck |= SqSet[b];
    }
  for (U = wBitboardB; U; BitClear (b, U))
    {
      b = BSF (U);
      A = AttB (b);
      DYN->wAtt |= A;
      if (A & bBitboardK)
	DYN->bKcheck |= SqSet[b];
      else if (bBitboardK & DIAG[b])
	{
	  T = AttB (POSITION->bKsq) & A;
	  DYN->wXray |= T;
	  if (T)
	    XRAYw[BSF (T)] = b;
	}
    }
  for (U = wBitboardR; U; BitClear (b, U))
    {
      b = BSF (U);
      A = AttR (b);
      DYN->wAtt |= A;
      if (A & bBitboardK)
	DYN->bKcheck |= SqSet[b];
      else if (bBitboardK & ORTHO[b])
	{
	  T = AttR (POSITION->bKsq) & A;
	  DYN->wXray |= T;
	  if (T)
	    XRAYw[BSF (T)] = b;
	}
    }
  for (U = wBitboardQ; U; BitClear (b, U))
    {
      b = BSF (U);
      AttR = AttR (b);
      AttB = AttB (b);
      A = AttB | AttR;
      DYN->wAtt |= A;
      if (A & bBitboardK)
	DYN->bKcheck |= SqSet[b];
      else if (bBitboardK & DIAG[b])
	{
	  T = AttB (POSITION->bKsq) & AttB;
	  DYN->wXray |= T;
	  if (T)
	    XRAYw[BSF (T)] = b;
	}
      else if (bBitboardK & ORTHO[b])
	{
	  T = AttR (POSITION->bKsq) & AttR;
	  DYN->wXray |= T;
	  if (T)
	    XRAYw[BSF (T)] = b;
	}
    }
  for (U = bBitboardN; U; BitClear (b, U))
    {
      b = BSF (U);
      A = AttN[b];
      DYN->Batt |= A;
      if (A & wBitboardK)
	DYN->wKcheck |= SqSet[b];
    }
  for (U = bBitboardB; U; BitClear (b, U))
    {
      b = BSF (U);
      A = AttB (b);
      DYN->Batt |= A;
      if (A & wBitboardK)
	DYN->wKcheck |= SqSet[b];
      else if (wBitboardK & DIAG[b])
	{
	  T = AttB (POSITION->wKsq) & A;
	  DYN->bXray |= T;
	  if (T)
	    XRAYb[BSF (T)] = b;
	}
    }
  for (U = bBitboardR; U; BitClear (b, U))
    {
      b = BSF (U);
      A = AttR (b);
      DYN->Batt |= A;
      if (A & wBitboardK)
	DYN->wKcheck |= SqSet[b];
      else if (wBitboardK & ORTHO[b])
	{
	  T = AttR (POSITION->wKsq) & A;
	  DYN->bXray |= T;
	  if (T)
	    XRAYb[BSF (T)] = b;
	}
    }
  for (U = bBitboardQ; U; BitClear (b, U))
    {
      b = BSF (U);
      AttB = AttB (b);
      AttR = AttR (b);
      A = AttB | AttR;
      DYN->Batt |= A;
      if (A & wBitboardK)
	DYN->wKcheck |= SqSet[b];
      else if (wBitboardK & DIAG[b])
	{
	  T = AttB (POSITION->wKsq) & AttB;
	  DYN->bXray |= T;
	  if (T)
	    XRAYb[BSF (T)] = b;
	}
      else if (wBitboardK & ORTHO[b])
	{
	  T = AttR (POSITION->wKsq) & AttR;
	  DYN->bXray |= T;
	  if (T)
	    XRAYb[BSF (T)] = b;
	}
    }
  A = (wBitboardP & (~FILEa)) << 7;
  T = A & bBitboardK;
  DYN->bKcheck |= (T >> 7);
  DYN->wAtt |= A;
  A = (wBitboardP & (~FILEh)) << 9;
  T = A & bBitboardK;
  DYN->bKcheck |= (T >> 9);
  DYN->wAtt |= A;
  A = (bBitboardP & (~FILEh)) >> 7;
  T = A & wBitboardK;
  DYN->wKcheck |= (T << 7);
  DYN->Batt |= A;
  A = (bBitboardP & (~FILEa)) >> 9;
  T = A & wBitboardK;
  DYN->wKcheck |= (T << 9);
  DYN->Batt |= A;
}

static void
AdjustPositionalGainB (typePOS *POSITION, int move)
{
  int v, p, m;
  if (DYN->cp)
    return;
  if (DYN->cp && POSITION->sq[TO (move)] != wEnumP)
    return;
  p = POSITION->sq[TO (move)];
  m = move & 07777;
  v = DYN->positional_valu - ((DYN - 1)->positional_valu);
  if (MAX_POS_GAIN (p ,m) <= v)
    MAX_POS_GAIN (p, m) = v;
  else
    MAX_POS_GAIN (p, m)--;
}

static void
AdjustPositionalGainW (typePOS *POSITION, int move)
{
  int v, p, m;
  if (DYN->cp)
    return;
  if (DYN->cp && POSITION->sq[TO (move)] != bEnumP)
    return;
  p = POSITION->sq[TO (move)];
  m = move & 07777;
  v = ((DYN - 1)->positional_valu) - DYN->positional_valu;
  if (MAX_POS_GAIN (p ,m) <= v)
    MAX_POS_GAIN (p, m) = v;
  else
    MAX_POS_GAIN (p, m)--;
}

#define HashSize ( 0x8000 )
#define HASH_MASK ( HashSize - 1 )

uint64 EvalHash[HashSize]; /* non atomico con 32-bits ? */

void
EvalHashClear ()
{
  int c;
  for (c = 0; c < HashSize; c++)
    EvalHash[c] = 0;
}

#ifdef HAS_PREFETCH
#define PREFETCH_PAWN_HASH __builtin_prefetch(&PEDONE_PTR, 1, 2);
#else
#define PREFETCH_PAWN_HASH
#endif

static int
MaterialValue (typePOS *POSITION)
{
  int Value =
    975 * (POPCNT (wBitboardQ) - POPCNT (bBitboardQ));
  Value +=
    500 * (POPCNT (wBitboardR) - POPCNT (bBitboardR));
  Value +=
    325 * (POPCNT (wBitboardB) - POPCNT (bBitboardB));
  Value +=
    325 * (POPCNT (wBitboardN) - POPCNT (bBitboardN));
  Value +=
    100 * (POPCNT (wBitboardP) - POPCNT (bBitboardP));
  if (wBitboardBL && wBitboardBD)
    Value += 50;
  if (bBitboardBL && bBitboardBD)
    Value -= 50;
  return Value;
}

static void
KingPawnWhite (typePOS *POSITION, int matval, uint8 TOKEN,
		  typePawnEval * PAWN_INFO)
{
  int Value, WhiteLeader, BlackLeader, sq, tr;
  uint8 C;
  uint64 A, T;
  if (PAWN_INFO->PAWN_HASH != DYN->PAWN_HASH)
    PawnEval (POSITION, PAWN_INFO);
  DYN->wXray = DYN->bXray = 0;
  Value = ((DYN->STATIC) + (PAWN_INFO->SCORE));
  Value = (sint16) (Value & 0xffff);
  WhiteLeader = 0;
  C = PAWN_INFO->wPassedFiles;
  while (C)
    {
      sq = BSR (FileArray[BSF (C)] & wBitboardP);
      tr = RANK (sq);
      BitClear (0, C);
      if ((ShepherdWK[sq] & wBitboardK) == 0)
	{
	  if (wBitboardOcc & OpenFileW[sq]
	      || (bBitboardK & QuadrantBKwtm[sq]) == 0)
	    continue;
	  if (WhiteLeader <= tr)
	    WhiteLeader = tr;
	}
      else if (WhiteLeader <= tr)
	WhiteLeader = tr;
    }
  BlackLeader = 0;
  C = PAWN_INFO->bPassedFiles;
  while (C)
    {
      sq = BSF (FileArray[BSF (C)] & bBitboardP);
      tr = R8 - RANK (sq);
      BitClear (0, C);
      if ((ShepherdBK[sq] & bBitboardK) == 0)
	{
	  if (bBitboardOcc & OpenFileB[sq]
	      || (wBitboardK & QuadrantWKwtm[sq]) ==
	      0)
	    continue;
	  if (BlackLeader <= tr)
	    BlackLeader = tr;
	}
      else if (BlackLeader <= tr)
	BlackLeader = tr;
    }
  DYN->Value = (TOKEN * (Value + matval)) / 128;
  DYN->bKcheck = DYN->wKcheck = 0;
  if (WhiteLeader > BlackLeader
      && (bBitboardP & InFrontB[R8 - WhiteLeader + 1]) == 0)
    DYN->Value += 150 + 50 * WhiteLeader;
  if (BlackLeader > WhiteLeader + 1
      && (wBitboardP & InFrontW[BlackLeader - 2]) == 0)
    DYN->Value -= 150 + 50 * BlackLeader;

  A = (wBitboardP & (~FILEa)) << 7;
  T = A & bBitboardK;
  DYN->bKcheck |= (T >> 7);
  DYN->wAtt = A;
  A = (wBitboardP & (~FILEh)) << 9;
  T = A & bBitboardK;
  DYN->bKcheck |= (T >> 9);
  DYN->wAtt |= A | AttK[POSITION->wKsq];
  A = (bBitboardP & (~FILEh)) >> 7;
  T = A & wBitboardK;
  DYN->wKcheck |= (T << 7);
  DYN->Batt = A;
  A = (bBitboardP & (~FILEa)) >> 9;
  T = A & wBitboardK;
  DYN->wKcheck |= (T << 9);
  DYN->Batt |= A | AttK[POSITION->bKsq];
  if (bBitboardK & AttK[POSITION->wKsq])
    {
      DYN->bKcheck |=
	SqSet[POSITION->wKsq];
      DYN->wKcheck |=
	SqSet[POSITION->bKsq];
    }
  if (DYN->Value > 0 && !wBitboardP)
    DYN->Value = 0;
  if (DYN->Value < 0 && !bBitboardP)
    DYN->Value = 0;
  if (DYN->Value > 0)
    {
      if ((wBitboardP & ~FILEh) == 0
	  && (bBitboardK | AttK[POSITION->bKsq]) &
	  SqSet[H8])
	DYN->Value = 0;
      if ((wBitboardP & ~FILEa) == 0
	  && (bBitboardK | AttK[POSITION->bKsq]) &
	  SqSet[A8])
	DYN->Value = 0;
      if ((DYN->flags & 28) == 28)
	{
	  sq = BSF (wBitboardP);
	  tr = RANK (sq);
	  Value =
	    YakovWTM[384 * POSITION->wKsq +
			 6 * POSITION->bKsq + tr - 1] &
	    (1 << FILE (sq));
	  if (!Value)
	    DYN->Value = 0;
	  else
	    DYN->Value =
	      ((sint16) (DYN->STATIC & 0xffff)) + 75 * tr + 250;
	}
    }
  if (DYN->Value < 0)
    {
      if ((bBitboardP & ~FILEh) == 0
	  && (wBitboardK | AttK[POSITION->wKsq]) &
	  SqSet[H1])
	DYN->Value = 0;
      if ((bBitboardP & ~FILEa) == 0
	  && (wBitboardK | AttK[POSITION->wKsq]) &
	  SqSet[A1])
	DYN->Value = 0;
      if ((DYN->flags & 28) == 28)
	{
	  sq = H8 - BSR (bBitboardP);
	  tr = RANK (sq);
	  Value =
	    YakovBTM[384 * (H8 - POSITION->bKsq) +
		       6 * (H8 - POSITION->wKsq) + tr - 1] &
	    (1 << FILE (sq));
	  if (!Value)
	    DYN->Value = 0;
	  else
	    DYN->Value =
	      ((sint16) (DYN->STATIC & 0xffff)) - 75 * tr - 250;
	}
    }
}

static void
KingPawnBlack (typePOS *POSITION, int matval, uint8 TOKEN,
		typePawnEval * PAWN_INFO)
{
  int Value, WhiteLeader, BlackLeader, sq, tr;
  uint8 C;
  uint64 A, T;
  if (PAWN_INFO->PAWN_HASH != DYN->PAWN_HASH)
    PawnEval (POSITION, PAWN_INFO);
  DYN->wXray = DYN->bXray = 0;
  Value = ((DYN->STATIC) + (PAWN_INFO->SCORE));
  Value = (sint16) (Value & 0xffff);
  WhiteLeader = 0;
  C = PAWN_INFO->wPassedFiles;
  while (C)
    {
      sq = BSR (FileArray[BSF (C)] & wBitboardP);
      tr = RANK (sq);
      BitClear (0, C);
      if ((ShepherdWK[sq] & wBitboardK) == 0)
	{
	  if (wBitboardOcc & OpenFileW[sq]
	      || (bBitboardK & QuadrantBKbtm[sq]) == 0)
	    continue;
	  if (WhiteLeader <= tr)
	    WhiteLeader = tr;
	}
      else if (WhiteLeader <= tr)
	WhiteLeader = tr;
    }
  BlackLeader = 0;
  C = PAWN_INFO->bPassedFiles;
  while (C)
    {
      sq = BSF (FileArray[BSF (C)] & bBitboardP);
      tr = R8 - RANK (sq);
      BitClear (0, C);
      if ((ShepherdBK[sq] & bBitboardK) == 0)
	{
	  if (bBitboardOcc & OpenFileB[sq]
	      || (wBitboardK & QuadrantWKbtm[sq]) == 0)
	    continue;
	  if (BlackLeader <= tr)
	    BlackLeader = tr;
	}
      else if (BlackLeader <= tr)
	BlackLeader = tr;
    }
  DYN->Value = -(TOKEN * (Value + matval)) / 128;
  DYN->bKcheck = DYN->wKcheck = 0;
  if (WhiteLeader > BlackLeader + 1
      && (bBitboardP & InFrontB[R8 - WhiteLeader + 2]) == 0)
    DYN->Value -= 150 + 50 * WhiteLeader;
  if (BlackLeader > WhiteLeader
      && (wBitboardP & InFrontW[BlackLeader - 1]) == 0)
    DYN->Value += 150 + 50 * BlackLeader;

  A = (wBitboardP & (~FILEa)) << 7;
  T = A & bBitboardK;
  DYN->bKcheck |= (T >> 7);
  DYN->wAtt = A;
  A = (wBitboardP & (~FILEh)) << 9;
  T = A & bBitboardK;
  DYN->bKcheck |= (T >> 9);
  DYN->wAtt |= A | AttK[POSITION->wKsq];
  A = (bBitboardP & (~FILEh)) >> 7;
  T = A & wBitboardK;
  DYN->wKcheck |= (T << 7);
  DYN->Batt = A;
  A = (bBitboardP & (~FILEa)) >> 9;
  T = A & wBitboardK;
  DYN->wKcheck |= (T << 9);
  DYN->Batt |= A | AttK[POSITION->bKsq];
  if (bBitboardK & AttK[POSITION->wKsq])
    {
      DYN->bKcheck |=
	SqSet[POSITION->wKsq];
      DYN->wKcheck |=
	SqSet[POSITION->bKsq];
    }
  if (DYN->Value < 0 && !wBitboardP)
    DYN->Value = 0;
  if (DYN->Value > 0 && !bBitboardP)
    DYN->Value = 0;
  if (DYN->Value < 0)
    {
      if ((wBitboardP & ~FILEh) == 0
	  && (AttK[POSITION->bKsq] | bBitboardK) &
	  SqSet[H8])
	DYN->Value = 0;
      if ((wBitboardP & ~FILEa) == 0
	  && (AttK[POSITION->bKsq] | bBitboardK) &
	  SqSet[A8])
	DYN->Value = 0;
      if ((DYN->flags & 28) == 28)
	{
	  sq = BSF (wBitboardP);
	  tr = RANK (sq);
	  Value =
	    YakovBTM[384 * POSITION->wKsq +
		       6 * POSITION->bKsq + tr -
		       1] & (1 << FILE (sq));
	  if (!Value)
	    DYN->Value = 0;
	  else
	    DYN->Value =
	      -((sint16) (DYN->STATIC & 0xffff)) - 75 * tr - 250;
	}
    }
  if (DYN->Value > 0)
    {
      if ((bBitboardP & ~FILEh) == 0
	  && (AttK[POSITION->wKsq] | wBitboardK) &
	  SqSet[H1])
	DYN->Value = 0;
      if ((bBitboardP & ~FILEa) == 0
	  && (AttK[POSITION->wKsq] | wBitboardK) &
	  SqSet[A1])
	DYN->Value = 0;
      if ((DYN->flags & 28) == 28)
	{
	  sq = H8 - BSR (bBitboardP);
	  tr = RANK (sq);
	  Value =
	    YakovWTM[384 * (H8 - POSITION->bKsq) +
			 6 * (H8 - POSITION->wKsq) + tr - 1]
	    & (1 << FILE (sq));
	  if (!Value)
	    DYN->Value = 0;
	  else
	    DYN->Value =
	      -((sint16) (DYN->STATIC & 0xffff)) + 75 * tr + 250;
	}
    }
}

void
Eval (typePOS *POSITION, int min, int max, int move)
{
  typePawnEval *PEDONE_PTR;
  int index, matval, Value;
  int b, tr, antiphase, phase;
  int to, cp, wKs, bKs;
  uint64 U, wKatt, wBatt, A, AttB, AttR;
  sint32 wKhit, wBhit;
  uint64 wGoodMinor, bGoodMinor, wSafeMob,
    bSafeMob, wOKxray, bOKxray;
  uint64 T, bPatt, wPatt;
  int open, end;
  uint8 bGoodAtt, wGoodAtt;
  uint8 TOKEN;
  int v, positional;
  typePawnEval PAWN_INFO[1];
  int ch;

  PEDONE_PTR =
    PawnHash + (DYN->PAWN_HASH & (PawnHashSize - 1));
  PREFETCH_PAWN_HASH;
  index = (DYN->material >> 8) & 0x7ffff;
  TOKEN = MATERIAL[index].token;
  DYN->flags = MATERIAL[index].flags;
  if (!(DYN->material & 0x80000000))
    matval = MATERIAL[index].Value;
  else
    {
      if (POPCNT (wBitboardQ) > 1
	  || POPCNT (bBitboardQ) > 1
	  || POPCNT (wBitboardR) > 2
	  || POPCNT (bBitboardR) > 2
	  || POPCNT (wBitboardBL) > 1
	  || POPCNT (bBitboardBL) > 1
	  || POPCNT (wBitboardBD) > 1
	  || POPCNT (bBitboardBD) > 1
	  || POPCNT (wBitboardN) > 2
	  || POPCNT (bBitboardN) > 2)
	{
	  TOKEN = 0x80;
	  matval = MaterialValue (POSITION);
	  DYN->flags = 0;
	  if (wBitboardQ | wBitboardR |
	      wBitboardB | wBitboardN)
	    DYN->flags |= 2;
	  if (bBitboardQ | bBitboardR |
	      bBitboardB | bBitboardN)
	    DYN->flags |= 1;
	}
      else
	{
	  matval = MATERIAL[index].Value;
	  DYN->material &= 0x7fffffff;
	}
    }

  if (((DYN->HASH ^
	EvalHash[DYN->HASH & HASH_MASK]) &
       0xffffffffffff0000) == 0)
    {
      Value =
	(int) ((sint16)
	       (EvalHash[DYN->HASH & HASH_MASK] &
		0xffff));
      DYN->lazy = 0;
      Mobility (POSITION);
      DYN->positional_valu =
	((POSITION->wtm) ? Value : -Value) - matval;
      DYN->Value = Value;
      if (move && !(DYN - 1)->lazy)
	POSITION->wtm ?
	  AdjustPositionalGainW (POSITION, move) : AdjustPositionalGainB (POSITION, move);
      return;
    }

#ifdef CON_ROBBO_BUILD
  int c = POPCNT (POSITION->OccupiedBW);
  if (c <= 5)
    {
      int va;
      Mobility (POSITION);
      if (TRIPLE_VALU (POSITION, &va))
	{
	  int molt = 21000 - (128 * c) - 64 * HEIGHT (POSITION);
	  if (va == 0)
	    DYN->Value = 0;
	  else
	    {
	      DYN->Value = (va > 0) ? molt : -molt;
	      DYN->Value +=
		(POSITION->wtm ? matval : -matval);
	    }
	  DYN->lazy = 1;
	  DYN->positional_valu = 0;
	  EvalHash[DYN->HASH & HASH_MASK] =
	    (DYN->HASH & 0xffffffffffff0000) | (DYN->Value & 0xffff);
	  return;
	}
    }
#endif

  memcpy (PAWN_INFO, PEDONE_PTR, sizeof (typePawnEval));
#if 1 /* HYATT hashing */
  PAWN_INFO->PAWN_HASH ^= (((uint64*) (PAWN_INFO)) + 0x1)[0];
  PAWN_INFO->PAWN_HASH ^= (((uint64*) (PAWN_INFO)) + 0x2)[0];
  PAWN_INFO->PAWN_HASH ^= (((uint64*) (PAWN_INFO)) + 0x3)[0];
#endif

  if ((DYN->material & 0xff) == 0)
    {
      POSITION->wtm ?
	KingPawnWhite (POSITION, matval, TOKEN, PAWN_INFO) :
	KingPawnBlack (POSITION, matval, TOKEN, PAWN_INFO);
      DYN->lazy = 1;
      DYN->positional_valu = 0;
      EvalHash[DYN->HASH & HASH_MASK] =
	(DYN->HASH & 0xffffffffffff0000) | (DYN->Value & 0xffff);
      return;
    }

#define WHITE_MINOR_ONLY (8 << 2)
#define BLACK_MINOR_ONLY (16 << 2)

  if ((DYN->flags & WHITE_MINOR_ONLY
       || DYN->flags & BLACK_MINOR_ONLY)
      && PAWN_INFO->PAWN_HASH != DYN->PAWN_HASH)
    PawnEval (POSITION, PAWN_INFO);

  if ((DYN->flags & WHITE_MINOR_ONLY
       && PAWN_INFO->wPfile_count <= 1)
      || (DYN->flags & BLACK_MINOR_ONLY
	  && PAWN_INFO->bPfile_count <= 1)
      || (DYN->flags & 128));
  else
    {
      if (POSITION->wtm)
	{
	  positional = (DYN - 1)->positional_valu;
	  cp = DYN->cp;
	  to = TO (move);
	  Value = PieceSquareValue[POSITION->sq[to]][to] - PieceSquareValue[POSITION->sq[to]][FROM (move)];
	  if (cp)
	    Value -= PieceSquareValue[cp][to];
	  phase = DYN->material & 0xff;
	  end = (sint16) (Value & 0xffff);
	  open = (end < 0) + (sint16) ((Value >> 16) & 0xffff);
	  antiphase = 32 - phase;
	  Value = (end * antiphase + open * phase) / 32;
	  positional += Value;
	  v = positional + matval;
	  if (v < -max - 16 * (int) (DYN - 1)->lazy
	      || v > -min + 16 * (int) (DYN - 1)->lazy)
	    {
	      DYN->lazy = (DYN - 1)->lazy + 1;
	      DYN->Value = v;
	      DYN->positional_valu = positional;
	      Mobility (POSITION);
	      return;
	    }
	}
      else
	{
	  positional = (DYN - 1)->positional_valu;
	  cp = DYN->cp;
	  to = TO (move);
	  Value = PieceSquareValue[POSITION->sq[to]][to] - PieceSquareValue[POSITION->sq[to]][FROM (move)];
	  if (cp)
	    Value -= PieceSquareValue[cp][to];
	  phase = DYN->material & 0xff;
	  end = (sint16) (Value & 0xffff);
	  open = (end < 0) + (sint16) ((Value >> 16) & 0xffff);
	  antiphase = 32 - phase;
	  Value = (end * antiphase + open * phase) / 32;
	  positional += Value;
	  v = positional + matval;
	  if (v < min - 16 * (int) (DYN - 1)->lazy
	      || v > max + 16 * (int) (DYN - 1)->lazy)
	    {
	      DYN->lazy = (DYN - 1)->lazy + 1;
	      DYN->Value = -v;
	      DYN->positional_valu = positional;
	      Mobility (POSITION);
	      return;
	    }
	}
    }

  wKs = POSITION->wKsq;
  bKs = POSITION->bKsq;
  wKatt = AttK[wKs];
  wBatt = AttK[bKs];
  bGoodAtt = wGoodAtt = 0;
  if (PAWN_INFO->PAWN_HASH != DYN->PAWN_HASH)
    PawnEval (POSITION, PAWN_INFO);
  Value = (DYN->STATIC) + (PAWN_INFO->SCORE);

  DYN->wXray = 0;

  A = (wBitboardP & (~FILEa)) << 7;
  T = A & bBitboardK;
  DYN->bKcheck = (T >> 7);
  wPatt = A;
  A = (wBitboardP & (~FILEh)) << 9;
  T = A & bBitboardK;
  DYN->bKcheck |= (T >> 9);
  wPatt |= A;
  DYN->wAtt = wPatt;
  A = (bBitboardP & (~FILEh)) >> 7;
  T = A & wBitboardK;
  DYN->wKcheck = (T << 7);
  bPatt = A;
  A = (bBitboardP & (~FILEa)) >> 9;
  T = A & wBitboardK;
  DYN->wKcheck |= (T << 9);
  bPatt |= A;
  DYN->Batt = bPatt;

  bOKxray = (~bBitboardP) & ~wPatt;
  wOKxray = (~wBitboardP) & ~bPatt;
  wGoodMinor =
    (wBitboardN | wBitboardB) &
    wPatt;
  bGoodMinor =
    (bBitboardN | bBitboardB) & bPatt;

  if (wPatt & wBatt)
    wBhit = HitP;
  else
    wBhit = 0;
  U = (POSITION->OccupiedBW >> 8) & wBitboardP;
  while (U)
    {
      b = BSF (U);
      Value -= PawnAntiMobility;
      BitClear (b, U);
    }
  wSafeMob = ~(bPatt | wBitboardOcc);

  U = wBitboardQ;
  while (U)
    {
      b = BSF (U);
      BitClear (b, U);
      AttB = AttB (b);
      AttR = AttR (b);
      if (bBitboardK & DIAG[b])
	{
	  T = AttB (bKs) & AttB;
	  if (T)
	    {
	      Value += wQxrayD[POSITION->sq[BSF (T)]];
	      DYN->wXray |= T;
	      XRAYw[BSF (T)] = b;
	    }
	}
      else if (bBitboardK & ORTHO[b])
	{
	  T = AttR (bKs) & AttR;
	  if (T)
	    {
	      Value += wQxrayO[POSITION->sq[BSF (T)]];
	      DYN->wXray |= T;
	      XRAYw[BSF (T)] = b;
	    }
	}
      A = AttB | AttR;
      T = A & wSafeMob;
      DYN->wAtt |= A;
      if (A & wBatt)
	wBhit += HitQ;
      if (A & bBitboardK)
	DYN->bKcheck |= SqSet[b];
      if (A & wKatt)
	{
	  Value += QguardK;
	}
      Value += MobQ (T);
      if (A & (~bPatt) & bBitboardOcc)
	{
	  Value += Qatt;
	}
      if (bBitboardP & AttPb[b])
	{
	  Value -= PattQ;
	  bGoodAtt += 1;
	}
      if (RANK (b) == R7)
	{
	  if ((bBitboardP | bBitboardK) & RANKS78)
	    {
	      Value += Queen7th;
	      if (wBitboardR & RANK7 & AttR
		  && bBitboardK & RANK8)
		{
		  Value += DoubQueen7th;
		}
	    }
	}
    }

  U = wBitboardR;
  while (U)
    {
      b = BSF (U);
      BitClear (b, U);
      A = AttR (b);
      DYN->wAtt |= A;
      if (bBitboardK & ORTHO[b])
	{
	  T = AttR (bKs) & A;
	  if (T)
	    {
	      Value += wRxray[POSITION->sq[BSF (T)]];
	      DYN->wXray |= T;
	      XRAYw[BSF (T)] = b;
	    }
	}
      if (A & wBatt)
	wBhit += HitR;
      if (A & bBitboardK)
	DYN->bKcheck |= SqSet[b];
      if (A & wKatt)
	{
	  Value += RguardK;
	}
      Value += MobR (A & wOKxray);

      if (A & (~bPatt) & bBitboardP)
	{
	  Value += RattP;
	}
      if (A &
	  ((bBitboardN | bBitboardB) &
	   ~bPatt))
	{
	  Value += RattBN;
	}
      if (A & bBitboardQ)
	{
	  Value += RattQ;
	  wGoodAtt += 1;
	}
      if (bBitboardP & AttPb[b])
	{
	  Value -= PattR;
	  bGoodAtt += 1;
	}

      if ((wBitboardP & OpenFileW[b]) == 0)
	{
	  Value += RookHalfOpen;
	  if ((bBitboardP & OpenFileW[b]) == 0)
	    {
	      T = bGoodMinor & OpenFileW[b];
	      if (!T)
		{
		  Value += RookOpenFile;
		}
	      else
		{
		  int t = BSF (T);
		  if ((IsolatedFiles[FILE (t)] &
		       InFrontB[RANK (t)] & wBitboardP)
		      == 0)
		    {
		      Value += RookOpenFixedMinor;
		    }
		  else
		    {
		      Value += RookOpenMinor;
		    }
		}
	    }
	  else
	    {
	      T = OpenFileW[b] & bBitboardP;
	      if (T)
		{
		  int t = BSF (T);
		  if ((IsolatedFiles[FILE (t)] &
		       InFrontW[RANK (t)] & bBitboardP)
		      == 0)
		    {
		      Value += RookHalfOpenPawn;
		    }
		}
	    }
	  if (bBitboardK & OpenFileW[b])
	    {
	      Value += RookHalfOpenKing;
	    }
	}

      if (SqSet[b] & wOutpost
	  && (IsolatedFiles[FILE (b)] & InFrontW[RANK (b)] &
	      bBitboardP) == 0)
	{
	  if (wBitboardP & AttPw[b])
	    {
	      Value += OutpostRook;
	      if (A &
		  (wBatt |
		   (bBitboardOcc & ~bPatt)) &
		  RankArray[RANK (b)])
		Value += OutpostRookGuarded;
	    }
	}

      if (RANK (b) == R8)
	{
	  if (bBitboardK & RANK8)
	    {
	      Value += RookKing8th;
	    }
	}
      if (RANK (b) == R7)
	{
	  if ((bBitboardP | bBitboardK) & RANKS78)
	    {
	      Value += Rook7thKingPawn;
	      if (bBitboardK & RANK8
		  && (wBitboardQ | wBitboardR) &
		  RANK7 & A)
		{
		  Value += DoubRook7thKingPawn;
		}
	    }
	}
      if (RANK (b) == R6
	  && (bBitboardP | bBitboardK) & RANKS678)
	{
	  Value += Rook6thKingPawn;
	}
    }

  wSafeMob |= bBitboardOcc ^ bBitboardP;

  U = wBitboardB;
  while (U)
    {
      b = BSF (U);
      BitClear (b, U);
      A = AttB (b);
      DYN->wAtt |= A;
      if (bBitboardK & DIAG[b])
	{
	  T = AttB (bKs) & A;
	  if (T)
	    {
	      Value += wBxray[POSITION->sq[BSF (T)]];
	      DYN->wXray |= T;
	      XRAYw[BSF (T)] = b;
	    }
	}
      if (A & wBatt)
	wBhit += HitB;
      if (A & bBitboardK)
	DYN->bKcheck |= SqSet[b];
      if (A & wKatt)
	{
	  Value += BguardK;
	}
      Value +=
	MobB (A & wSafeMob,
			  InFrontW[RANK (b)]);

      if (A & (~bPatt) & bBitboardP)
	{
	  Value += BattP;
	}
      if (A & (~bPatt) & bBitboardN)
	{
	  Value += BattN;
	}
      if (A & (bBitboardR | bBitboardQ))
	{
	  Value += BattRQ;
	  wGoodAtt += 1;
	}
      if (bBitboardP & AttPb[b])
	{
	  Value -= PattB;
	  bGoodAtt += 1;
	}

      if (SqSet[b] & LIGHT)
	{
	  Value -=
	    (PAWN_INFO->wPlight +
	     PAWN_INFO->bPlight / 2) * SCORE (1, 1);
	  Value +=
	    POPCNT (bBitboardP & LIGHT &
		    InFrontB[RANK (b)] & ~bPatt) *
	    SCORE (0, 2);
	}
      else
	{
	  Value -=
	    (PAWN_INFO->wPdark +
	     PAWN_INFO->bPdark / 2) * SCORE (1, 1);
	  Value +=
	    POPCNT (bBitboardP & DARK &
		    InFrontB[RANK (b)] & ~bPatt) *
	    SCORE (0, 2);
	}

      if (SqSet[b] & wOutpost
	  && (IsolatedFiles[FILE (b)] & InFrontW[RANK (b)] &
	      bBitboardP) == 0)
	{
	  if (wBitboardP & AttPw[b])
	    {
	      Value += OutputBishop;
	      if (A &
		  (wBatt |
		   (bBitboardOcc & ~bPatt)))
		Value += OutputBishopGuarded;
	    }
	}
      if (POSITION->sq[BishopTrapSq[b]] == bEnumP)
	{
	  Value -= BishopTrapValue;
	  if (POSITION->sq[GoodBishopTrapSq[b]] == bEnumP)
	    {
	      Value -= BishopTrapGuardValu;
	    }
	}
    }

  U = wBitboardN;
  while (U)
    {
      b = BSF (U);
      BitClear (b, U);
      A = AttN[b];
      DYN->wAtt |= A;
      if (A & (wBatt | bBitboardK))
	wBhit += HitN;
      if (A & bBitboardK)
	DYN->bKcheck |= SqSet[b];
      if (A & (wKatt | wBitboardK))
	{
	  Value += NguardK;
	}
      Value +=
	MobN (A & wSafeMob,
			  InFrontW[RANK (b)]);

      if (A & (~bPatt) & bBitboardP)
	{
	  Value += NattP;
	}
      if (A & (~bPatt) & bBitboardB)
	{
	  Value += NattB;
	}
      if (A & (bBitboardR | bBitboardQ))
	{
	  Value += NattRQ;
	  wGoodAtt += 1;
	}
      if (bBitboardP & AttPb[b])
	{
	  Value -= PattN;
	  bGoodAtt += 1;
	}

      if (SqSet[b] & wOutpost
	  && (IsolatedFiles[FILE (b)] & InFrontW[RANK (b)] &
	      bBitboardP) == 0)
	{
	  Value += OutpostKnight;
	  if (wBitboardP & AttPw[b])
	    {
	      Value += OutpostKnightPawn;
	      if (A &
		  (wBatt |
		   (bBitboardOcc & ~bPatt)))
		{
		  Value += OutpostKnightGuarded;
		  if (RANK (b) == R5)
		    Value += OutpostKnight5th;
		  if (FILE (b) == FD || FILE (b) == FE)
		    Value += OutputKnightONde;
		}
	    }
	}
    }

  if (bPatt & wKatt)
    wKhit = HitP;
  else
    wKhit = 0;
  U = (POSITION->OccupiedBW << 8) & bBitboardP;
  DYN->bXray = 0;
  while (U)
    {
      b = BSF (U);
      Value += PawnAntiMobility;
      BitClear (b, U);
    }
  bSafeMob = ~(wPatt | bBitboardOcc);

  U = bBitboardQ;
  while (U)
    {
      b = BSF (U);
      BitClear (b, U);
      AttB = AttB (b);
      AttR = AttR (b);
      if (wBitboardK & DIAG[b])
	{
	  T = AttB (wKs) & AttB;
	  if (T)
	    {
	      Value -= bQxrayD[POSITION->sq[BSF (T)]];
	      DYN->bXray |= T;
	      XRAYb[BSF (T)] = b;
	    }
	}
      else if (wBitboardK & ORTHO[b])
	{
	  T = AttR (wKs) & AttR;
	  if (T)
	    {
	      Value -= bQxrayO[POSITION->sq[BSF (T)]];
	      DYN->bXray |= T;
	      XRAYb[BSF (T)] = b;
	    }
	}
      A = AttB | AttR;
      T = A & bSafeMob;
      DYN->Batt |= A;
      if (A & wKatt)
	wKhit += HitQ;
      if (A & wBitboardK)
	DYN->wKcheck |= SqSet[b];
      if (A & wBatt)
	{
	  Value -= QguardK;
	}
      Value -= MobQ (T);

      if (A & (~wPatt) & wBitboardOcc)
	{
	  Value -= Qatt;
	}
      if (wBitboardP & AttPw[b])
	{
	  Value += PattQ;
	  wGoodAtt += 1;
	}

      if (RANK (b) == R2)
	{
	  if ((wBitboardP | wBitboardK) & RANKS12)
	    {
	      Value -= Queen7th;
	      if (bBitboardR & RANK2 & AttR
		  && wBitboardK & RANK1)
		{
		  Value -= DoubQueen7th;
		}
	    }
	}
    }

  U = bBitboardR;
  while (U)
    {
      b = BSF (U);
      BitClear (b, U);
      A = AttR (b);
      DYN->Batt |= A;
      if (wBitboardK & ORTHO[b])
	{
	  T = A & AttR (wKs);
	  if (T)
	    {
	      Value -= bRxray[POSITION->sq[BSF (T)]];
	      DYN->bXray |= T;
	      XRAYb[BSF (T)] = b;
	    }
	}
      if (A & wKatt)
	wKhit += HitR;
      if (A & wBitboardK)
	DYN->wKcheck |= SqSet[b];
      if (A & wBatt)
	{
	  Value -= RguardK;
	}
      Value -= MobR (A & bOKxray);

      if (A & (~wPatt) & wBitboardP)
	{
	  Value -= RattP;
	}
      if (A & (wBitboardN | wBitboardB) &
	  ~wPatt)
	{
	  Value -= RattBN;
	}
      if (A & wBitboardQ)
	{
	  Value -= RattQ;
	  bGoodAtt += 1;
	}
      if (wBitboardP & AttPw[b])
	{
	  Value += PattR;
	  wGoodAtt += 1;
	}

      if ((bBitboardP & OpenFileB[b]) == 0)
	{
	  Value -= RookHalfOpen;
	  if ((wBitboardP & OpenFileB[b]) == 0)
	    {
	      T = wGoodMinor & OpenFileB[b];
	      if (!T)
		{
		  Value -= RookOpenFile;
		}
	      else
		{
		  int t = BSR (T);
		  if ((IsolatedFiles[FILE (t)] &
		       InFrontW[RANK (t)] & bBitboardP)
		      == 0)
		    {
		      Value -= RookOpenFixedMinor;
		    }
		  else
		    {
		      Value -= RookOpenMinor;
		    }
		}
	    }
	  else
	    {
	      T = OpenFileB[b] & wBitboardP;
	      if (T)
		{
		  int t = BSR (T);
		  if ((IsolatedFiles[FILE (t)] &
		       InFrontB[RANK (t)] & wBitboardP)
		      == 0)
		    {
		      Value -= RookHalfOpenPawn;
		    }
		}
	    }
	  if (wBitboardK & OpenFileB[b])
	    {
	      Value -= RookHalfOpenKing;
	    }
	}

      if (SqSet[b] & bOutpost
	  && (IsolatedFiles[FILE (b)] & InFrontB[RANK (b)] &
	      wBitboardP) == 0)
	{
	  if (bBitboardP & AttPb[b])
	    {
	      Value -= OutpostRook;
	      if (A &
		  (wKatt |
		   (wBitboardOcc & ~wPatt)) &
		  RankArray[RANK (b)])
		Value -= OutpostRookGuarded;
	    }
	}

      if (RANK (b) == R1)
	{
	  if (wBitboardK & RANK1)
	    {
	      Value -= RookKing8th;
	    }
	}
      if (RANK (b) == R2)
	{
	  if ((wBitboardP | wBitboardK) & RANKS12)
	    {
	      Value -= Rook7thKingPawn;
	      if (wBitboardK & RANK1
		  && (bBitboardQ | bBitboardR) & RANK2 &
		  A)
		{
		  Value -= DoubRook7thKingPawn;
		}
	    }
	}
      if (RANK (b) == R3
	  && (wBitboardP | wBitboardK) & RANKS123)
	{
	  Value -= Rook6thKingPawn;
	}
    }

  bSafeMob |= wBitboardOcc ^ wBitboardP;

  U = bBitboardB;
  while (U)
    {
      b = BSF (U);
      BitClear (b, U);
      A = AttB (b);
      DYN->Batt |= A;
      if (wBitboardK & DIAG[b])
	{
	  T = A & AttB (wKs);
	  if (T)
	    {
	      Value -= bBxray[POSITION->sq[BSF (T)]];
	      DYN->bXray |= T;
	      XRAYb[BSF (T)] = b;
	    }
	}
      if (A & wKatt)
	wKhit += HitB;
      if (A & wBitboardK)
	DYN->wKcheck |= SqSet[b];
      if (A & wBatt)
	{
	  Value -= BguardK;
	}
      Value -=
	MobB (A & bSafeMob,
			  InFrontB[RANK (b)]);

      if (A & (~wPatt) & wBitboardP)
	{
	  Value -= BattP;
	}
      if (A & (~wPatt) & wBitboardN)
	{
	  Value -= BattN;
	}
      if (A & (wBitboardR | wBitboardQ))
	{
	  Value -= BattRQ;
	  bGoodAtt += 1;
	}
      if (wBitboardP & AttPw[b])
	{
	  Value += PattB;
	  wGoodAtt += 1;
	}

      if (SqSet[b] & LIGHT)
	{
	  Value +=
	    (PAWN_INFO->bPlight +
	     PAWN_INFO->wPlight / 2) * SCORE (1, 1);
	  Value -=
	    POPCNT (wBitboardP & LIGHT &
		    InFrontW[RANK (b)] & ~wPatt) *
	    SCORE (0, 2);
	}
      else
	{
	  Value +=
	    (PAWN_INFO->bPdark +
	     PAWN_INFO->wPdark / 2) * SCORE (1, 1);
	  Value -=
	    POPCNT (wBitboardP & DARK &
		    InFrontW[RANK (b)] & ~wPatt) *
	    SCORE (0, 2);
	}

      if (SqSet[b] & bOutpost
	  && (IsolatedFiles[FILE (b)] & InFrontB[RANK (b)] &
	      wBitboardP) == 0)
	{
	  if (bBitboardP & AttPb[b])
	    {
	      Value -= OutputBishop;
	      if (A &
		  (wKatt |
		   (wBitboardOcc & ~wPatt)))
		Value -= OutputBishopGuarded;
	    }
	}

      if (POSITION->sq[BishopTrapSq[b]] == wEnumP)
	{
	  Value += BishopTrapValue;
	  if (POSITION->sq[GoodBishopTrapSq[b]] == wEnumP)
	    {
	      Value += BishopTrapGuardValu;
	    }
	}
    }

  U = bBitboardN;
  while (U)
    {
      b = BSF (U);
      BitClear (b, U);
      A = AttN[b];
      DYN->Batt |= A;
      if (A & (wKatt | wBitboardK))
	wKhit += HitN;
      if (A & wBitboardK)
	DYN->wKcheck |= SqSet[b];
      if (A & (wBatt | bBitboardK))
	{
	  Value -= NguardK;
	}
      Value -=
	MobN (A & bSafeMob,
			  InFrontB[RANK (b)]);

      if (A & (~wPatt) & wBitboardP)
	{
	  Value -= NattP;
	}
      if (A & (~wPatt) & wBitboardB)
	{
	  Value -= NattB;
	}
      if (A & (wBitboardR | wBitboardQ))
	{
	  Value -= NattRQ;
	  bGoodAtt += 1;
	}
      if (wBitboardP & AttPw[b])
	{
	  Value += PattN;
	  wGoodAtt += 1;
	}

      if (SqSet[b] & bOutpost
	  && (IsolatedFiles[FILE (b)] & InFrontB[RANK (b)] &
	      wBitboardP) == 0)
	{
	  Value -= OutpostKnight;
	  if (bBitboardP & AttPb[b])
	    {
	      Value -= OutpostKnightPawn;
	      if (A &
		  (wKatt |
		   (wBitboardOcc & ~wPatt)))
		{
		  Value -= OutpostKnightGuarded;
		  if (RANK (b) == R4)
		    Value -= OutpostKnight5th;
		  if (FILE (b) == FD || FILE (b) == FE)
		    Value -= OutputKnightONde;
		}
	    }
	}
    }

  DYN->wAtt |= wKatt;
  DYN->Batt |= wBatt;
  if (wBatt & wBitboardK)
    {
      DYN->wKcheck |=
	SqSet[POSITION->bKsq];
      DYN->bKcheck |=
	SqSet[POSITION->wKsq];
    }

  if ((~DYN->Batt) & wKatt & bBitboardP)
    {
      Value += KingAttUnguardedPawn;
    }

  T = RookTrapped[wKs] & wBitboardR;
  if (T)
    {
      int t = BSF (T);
      T = OpenFileW[t] & wBitboardP;
      if (T)
	{
	  t = BSF (T);
	  t >>= 3;
	  Value -= SCORE (10 * (6 - t), 0);
	}
    }

  if (wKatt & wBatt)
    wKhit += HitK;
  ch =
    (((KingSafetyMult[wKhit >> 16] *
       (wKhit & 0xffff)) / KingSafetyDivider) << 16) +
    PAWN_INFO->wKdanger;
  if (!bBitboardQ)
    {
      ch >>= 16;
      ch *=
	POPCNT (bBitboardR | bBitboardN |
		bBitboardB);
      ch >>= 3;
      ch <<= 16;
    }
  Value -= ch;

  if ((~DYN->wAtt) & wBatt & wBitboardP)
    {
      Value -= KingAttUnguardedPawn;
    }

  T = RookTrapped[bKs] & bBitboardR;
  if (T)
    {
      int t = BSR (T);
      T = OpenFileB[t] & bBitboardP;
      if (T)
	{
	  t = BSR (T);
	  t >>= 3;
	  Value += SCORE (10 * (t - 1), 0);
	}
    }

  if (wKatt & wBatt)
    wBhit += HitK;
  ch =
    (((KingSafetyMult[wBhit >> 16] *
       (wBhit & 0xffff)) / KingSafetyDivider) << 16) +
    PAWN_INFO->bKdanger;
  if (!wBitboardQ)
    {
      ch >>= 16;
      ch *=
	POPCNT (wBitboardR | wBitboardN |
		wBitboardB);
      ch >>= 3;
      ch <<= 16;
    }
  Value += ch;

  if (wGoodAtt >= 2)
    {
      Value += MultipleAtt;
    }
  if (bGoodAtt >= 2)
    {
      Value -= MultipleAtt;
    }

#define QueenEnd ( (DYN->flags & 28) == 4)
#define RookEnd ( (DYN->flags & 28) == 8)

  if ((wBitboardR | wBitboardQ) &
      CrampFile[FILE (bKs)])
    {
      Value += SCORE (0, 5);
      if ((CrampFile[FILE (bKs)] &
	   (wBitboardP | bBitboardP)) == 0)
	Value += SCORE (5, 15);
    }
  if ((bBitboardR | bBitboardQ) &
      CrampFile[FILE (wKs)])
    {
      Value -= SCORE (0, 5);
      if ((CrampFile[FILE (wKs)] &
	   (bBitboardP | wBitboardP)) == 0)
	Value -= SCORE (5, 15);
    }

  U = PAWN_INFO->wPassedFiles;
  while (U)
    {
      b = BSR (FileArray[BSF (U)] & wBitboardP);
      BitClear (0, U);
      tr = RANK (b);
      if (tr <= R3)
	continue;
      if (RookEnd)
	{
	  if (wBitboardR & OpenFileW[b])
	    {
	      if (tr == R7)
		{
		  Value -= Rook7thEnd;
		}
	      else if (tr == R6)
		{
		  Value -= Rook6thEnd;
		}
	    }
	  if (OpenFileW[b] & wBitboardK
	      && CrampFile[FILE (wKs)] & bBitboardR)
	    Value -= SCORE (0, 1 << (tr - R2));
	}
      if (POSITION->sq[b + 8] == 0)
	{
	  Value += PassedPawnCanMove[tr];
	}
      if ((OpenFileW[b] & wBitboardOcc) == 0)
	{
	  Value += PassedPawnMeClear[tr];
	}
      if ((OpenFileW[b] & bBitboardOcc) == 0)
	{
	  Value += PassedPawnOppClear[tr];
	}
      if ((OpenFileW[b] & (~DYN->wAtt) &
	   DYN->Batt) == 0)
	{
	  Value += PassedPawnIsFree[tr];
	}
      if (QueenEnd)
	{
	  if (tr == R7 && wBitboardQ & OpenFileW[b])
	    {
	      Value -= Queen7thEnd;
	    }
	  Value += RankQueenEnd[tr];
	}
    }

  U = PAWN_INFO->bPassedFiles;
  while (U)
    while (U)
      {
	b = BSF (FileArray[BSF (U)] & bBitboardP);
	BitClear (0, U);
	tr = RANK (b);
	if (tr >= R6)
	  continue;
	if (RookEnd)
	  {
	    if (bBitboardR & OpenFileB[b])
	      {
		if (tr == R2)
		  {
		    Value += Rook7thEnd;
		  }
		else if (tr == R3)
		  {
		    Value += Rook6thEnd;
		  }
	      }
	    if (OpenFileB[b] & bBitboardK
		&& CrampFile[FILE (bKs)] &
		wBitboardR)
	      Value += SCORE (0, 1 << (R7 - tr));
	  }
	if (POSITION->sq[b - 8] == 0)
	  {
	    Value -= PassedPawnCanMove[7 - tr];
	  }
	if ((OpenFileB[b] & bBitboardOcc) == 0)
	  {
	    Value -= PassedPawnMeClear[7 - tr];
	  }
	if ((OpenFileB[b] & wBitboardOcc) == 0)
	  {
	    Value -= PassedPawnOppClear[7 - tr];
	  }
	if ((OpenFileB[b] & DYN->
	     wAtt & ~DYN->Batt) == 0)
	  {
	    Value -= PassedPawnIsFree[7 - tr];
	  }
	if (QueenEnd)
	  {
	    if (tr == R2 && bBitboardQ & OpenFileB[b])
	      {
		Value += Queen7thEnd;
	      }
	    Value -= RankQueenEnd[7 - tr];
	  }
      }

  phase = DYN->material & 0xff;
  end = (sint16) (Value & 0xffff);
  open = (end < 0) + (sint16) ((Value >> 16) & 0xffff);
  antiphase = 32 - phase;
  Value = end * antiphase + open * phase;
  Value = Value / 32 + matval;
  Value = (Value * TOKEN) / 128;

  if (Value > 0)
    Value -= (PAWN_INFO->wDrawWeight * MIN (Value, 100)) / 64;
  else
    Value += (PAWN_INFO->bDrawWeight * MIN (-Value, 100)) / 64;

#define BISHOP_KNIGHT_MATE (DYN->flags & 128)
#define MAX_DIST(i,j) ( MAX (FileDistance (i, j), RankDistance (i, j) ) )
#define MIN_DIST(i,j) ( MIN ( FileDistance (i, j), RankDistance (i, j) ) )

  if (BISHOP_KNIGHT_MATE)
    {
      if (Value > 0)
	{
	  if (wBitboardBL)
	    Value -=
	      20 * MIN (MAX_DIST (A8, POSITION->bKsq),
			   MAX_DIST (H1, POSITION->bKsq)) +
	      10 * MIN (MIN_DIST (A8, POSITION->bKsq),
			   MIN_DIST (H1, POSITION->bKsq));
	  else
	    Value -=
	      20 * MIN (MAX_DIST (A1, POSITION->bKsq),
			   MAX_DIST (H8, POSITION->bKsq)) +
	      10 * MIN (MIN_DIST (A1, POSITION->bKsq),
			   MIN_DIST (H8, POSITION->bKsq));
	}
      else
	{
	  if (bBitboardBL)
	    Value +=
	      20 * MIN (MAX_DIST (A8, POSITION->wKsq),
			   MAX_DIST (H1, POSITION->wKsq)) +
	      10 * MIN (MIN_DIST (A8, POSITION->wKsq),
			   MIN_DIST (H1, POSITION->wKsq));
	  else
	    Value +=
	      20 * MIN (MAX_DIST (A1, POSITION->wKsq),
			   MAX_DIST (H8, POSITION->wKsq)) +
	      10 * MIN (MIN_DIST (A1, POSITION->wKsq),
			   MIN_DIST (H8, POSITION->wKsq));
	}
    }

  if (DYN->reversible > 50)
    {
      Value *= (114 - DYN->reversible);
      Value /= 64;
    }
/*/
#undef WHITE_MINOR_ONLY 
#undef BLACK_MINOR_ONLY 
/*/
#define WHITE_MINOR_ONLY (DYN->flags & 32)
#define WHITE_HAS_PIECE (DYN->flags & 2)
#define BLACK_MINOR_ONLY (DYN->flags & 64)
#define BLACK_HAS_PIECE (DYN->flags & 1)

  if (Value > 0)
    {
      if (!POSITION->wtm && !BLACK_HAS_PIECE
	  && (bBitboardK ^ bBitboardP) == bBitboardOcc
	  && !((bBitboardP >> 8) & ~POSITION->OccupiedBW)
	  && !(AttK[POSITION->bKsq] &
	       ~DYN->wAtt)
	  && !DYN->bKcheck)
	Value = 0;
      if (WHITE_MINOR_ONLY)
	{
	  if (wBitboardN)
	    {
	      if (wBitboardP == SqSet[A7]
		  && (bBitboardK |
		      AttK[POSITION->bKsq]) &
		  SqSet[A8])
		Value = 0;
	      if (wBitboardP == SqSet[H7]
		  && (bBitboardK |
		      AttK[POSITION->bKsq]) &
		  SqSet[H8])
		Value = 0;
	    }
	  else if (wBitboardBL && !(wBitboardP & NOTh)
		   && (bBitboardK |
		       AttK[POSITION->bKsq]) &
		   SqSet[H8])
	    {
	      if (wBitboardP & SqSet[H5]
		  && bBitboardP ==
		  (SqSet[G7] | SqSet[H6]));
	      else
		Value = 0;
	    }
	  else if (wBitboardBD && !(wBitboardP & NOTa)
		   && (bBitboardK |
		       AttK[POSITION->bKsq]) &
		   SqSet[A8])
	    {
	      if (wBitboardP & SqSet[A5]
		  && bBitboardP ==
		  (SqSet[B7] | SqSet[A6]));
	      else
		Value = 0;
	    }
	  if (!wBitboardP)
	    Value = 0;
	}
    }

  else
    {
      if (POSITION->wtm && !WHITE_HAS_PIECE
	  && (wBitboardK ^ wBitboardP) == wBitboardOcc
	  && !((wBitboardP << 8) & ~POSITION->OccupiedBW)
	  && !(AttK[POSITION->wKsq] &
	       ~DYN->Batt)
	  && !DYN->wKcheck)
	Value = 0;

      if (BLACK_MINOR_ONLY)
	{
	  if (bBitboardN)
	    {
	      if (bBitboardP == SqSet[A2]
		  && (wBitboardK |
		      AttK[POSITION->wKsq]) &
		  SqSet[A1])
		Value = 0;
	      if (bBitboardP == SqSet[H2]
		  && (wBitboardK |
		      AttK[POSITION->wKsq]) &
		  SqSet[H1])
		Value = 0;
	    }
	  else if (bBitboardBD && !(bBitboardP & NOTh)
		   && (wBitboardK |
		       AttK[POSITION->wKsq]) &
		   SqSet[H1])
	    {
	      if (bBitboardP & SqSet[H4]
		  && wBitboardP ==
		  (SqSet[G2] | SqSet[H3]));
	      else
		Value = 0;
	    }
	  else if (bBitboardBL && !(bBitboardP & NOTa)
		   && (wBitboardK |
		       AttK[POSITION->wKsq]) &
		   SqSet[A1])
	    {
	      if (bBitboardP & SqSet[A4]
		  && wBitboardP ==
		  (SqSet[B2] | SqSet[A3]));
	      else
		Value = 0;
	    }
	  if (!bBitboardP)
	    Value = 0;
	}
    }

  DYN->Value = POSITION->wtm ? Value : -Value;
  DYN->positional_valu = Value - matval;
  DYN->lazy = 0;
  EvalHash[DYN->HASH & HASH_MASK] =
    (DYN->HASH & 0xffffffffffff0000) | (DYN->Value & 0xffff);
  if (move && !(DYN - 1)->lazy)
    POSITION->wtm ?
      AdjustPositionalGainW (POSITION, move) : AdjustPositionalGainB (POSITION, move);

}
