#include "RobboLito.h"
#include <string.h>
#include "control.h"

static void
SetOption (char *string)
{
  char *v;
  int i, Value;
  if (!memcmp (string, "Hash", 4) || !memcmp (string, "TranspositionalTabularSizing", 28))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  Value = InitHash (Value);
	  SEND ("Optional Hash %d\n", Value);
	}
    }
  if (!memcmp (string, "PawnsHash", 9) || !memcmp (string, "PawnsZobrist", 12))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  Value = InitPawnHash (Value);
	  SEND ("Optional PawnsHash %d\n", Value);
	}
    }
  if (!memcmp (string, "MultiPV", 7))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  MULTI_PV = Value;
	  if (MULTI_PV <= 1)
	    MULTI_PV = 1;
	  if (MULTI_PV >= 250)
	    MULTI_PV = 250;
	  SEND ("Optional MultiPV %d (beta funzione)\n", MULTI_PV);
	}
    }
  if (!memcmp (string, "MultiCentiPawnPV", 16))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  MULTI_CENTI_PAWN_PV = Value;
	  if (MULTI_CENTI_PAWN_PV <= 1)
	    MULTI_CENTI_PAWN_PV = 1;
	  if (MULTI_CENTI_PAWN_PV >= 65535)
	    MULTI_CENTI_PAWN_PV = 65535;
	  SEND ("Optional MultiCentiPawnPV %d (beta funzione)\n", MULTI_CENTI_PAWN_PV);
	}
    }
  if (!memcmp (string, "Threads", 7))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  if (Value <= 0)
	    Value = 1;
	  if (Value > 64)
	    Value = 64;
	  if (Value > MAX_CPUS)
	    Value = MAX_CPUS;
	  CPUS_SIZE = Value;
	  SEND ("Optional Threads %d\n", Value);
	}
    }
  if (!memcmp (string, "Multicore", 9))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    TITANIC_MODE = FALSE;
	  if (!strcmp (v + 6, "true"))
	    TITANIC_MODE = TRUE;
	}
    }
}

static void
uci ()
{
	SEND ("id name %s %s\n", EPONYM, VERSION);
	SEND ("id author Yakov Petrovich Golyadkin, ");
	SEND ("Igor Igorovich Igoronov, Roberto Pescatore, ");
	SEND ("Yusuf Ralf Weisskopf, ");
	SEND ("Ivan Skavinsky Skavar\n");
	SEND ("id copyright Yakov Petrovich Golyadkin (all)\n");
	SEND ("id 92th year from Revolution, PUBLICDOMAIN (workers)\n");
	SEND ("id dedication To Vladimir Ilyich\n");
	SEND ("option name Hash ");
	SEND ("type spin min 1 max 16384 default 32\n");
	SEND ("option name PawnHash ");
	SEND ("type spin min 1 max 1024 default 2\n");
	SEND ("option name Multicore type check default false\n");
	SEND ("option name Threads type spin min 1 max %d default 1\n", MAX_CPUS);
	SEND ("option name MultiPV type spin min 1 max 250 default 1\n");
	SEND ("option name MultiCentiPawnPV type spin min 1 max 65535 default 65535\n");
	SEND ("uciok\n"); 
}

static void
readyok ()
{
  SEND ("readyok\n");
}

static void
quit ()
{
  exit (0);
}

static void
ParseInput (typePOS *POSITION, char *I)
{
  if (!strcmp (I, "quit"))
    quit ();
  if (!strcmp (I, "stop"))
    HaltSearch (0);
  if (!strcmp (I, "isready"))
    readyok ();
  if (!strcmp (I, "ponderhit"))
    ponderhit ();
  if (!strcmp (I, "ucinewgame"))
    {
      HaltSearch (0);
      NewGame (POSITION, TRUE);
    }
  if (JUMP_IS_SET)
    return;
#ifdef UTILITIES
  if (!memcmp (I, "perft-check", 11))
    Perfd (POSITION, atoi (I+12), atoi (I+14)); /* HACK */
  if (!memcmp (I, "perft ", 6))
    PERFD (POSITION, atoi (I+6));
#endif
  if (!memcmp (I, "go", 2))
    {
      InitSearch (POSITION, I);
      if (BOARD_IS_OK)
	Search (POSITION);
    }
  if (!memcmp (I, "position", 8))
    InitPosition (POSITION, I + 9);
  if (!memcmp (I, "setoption name", 14))
    SetOption (I + 15);
  if (!strcmp (I, "uci"))
    uci ();
}

void
Input (typePOS *POSITION)
{
  char I[65536];
  fgets (I, 65536, stdin);
  I[strlen (I) - 1] = 0;
  ParseInput (POSITION, I);
}
