
#include "RobboLito.h"

void pedone_reset ()
{
  memset (PawnHash, 0,
	  PawnHashSize * sizeof (typePawnEval));
}

int
InitPawnHash (int mb)
{
  if (mb > 1024)
    mb = 1024;
  PawnHashSize = ((1 << BSR (mb)) << 20) / sizeof (typePawnEval);
  mb = (PawnHashSize * sizeof (typePawnEval)) >> 20;
  if (PawnHash)
    free (PawnHash);
  POSIX_MEMALIGN (PawnHash, 64,
		  PawnHashSize * sizeof (typePawnEval));
  pedone_reset ();
  return (mb);
}

void
ResetPositionalGain ()
{
  int p, m;
#ifdef MULTIPLE_POS_GAIN
  int cpu;
  for (cpu = 0; cpu < MAX_CPUS; cpu++)
#endif
    for (p = 0; p < 0x10; p++)
      for (m = 0; m < 010000; m++)
#ifdef MULTIPLE_POS_GAIN
	MAX_POSITIONAL_GAIN[cpu][p][m] = 0;
#else
        MAX_POSITIONAL_GAIN[p][m] = 0;
#endif
}

void
ResetHistory ()
{
  int pi, sq;
#ifdef MULTIPLE_HISTORY
  int cpu;
  for (cpu = 0; cpu < MAX_CPUS; cpu++)
#endif
    for (pi = 0; pi < 0x10; pi++)
      for (sq = A1; sq <= H8; sq++)
#ifdef MULTIPLE_HISTORY
	HISTORY[cpu][pi][sq] = 0x800;
#else
	HISTORY[pi][sq] = 0x800;
#endif
}

static void
Banner ()
{
  printf ("%s %s\n", EPONYM, VERSION);
#ifdef HAS_PREFETCH
  printf ("Compiled With PREFETCH\n");
#endif
#ifdef HAS_POPCNT
  printf ("Compiled With POPCNT\n");
#endif
#ifdef UTILITIES
  printf ("Compiled With UTILITIES\n");
#endif
#ifdef YUSUF_MULTICORE
  printf ("Windows Multicore Version\n");
  printf ("Compiled By KLO\n");
#endif
}

int
main ()
{
  int i;
  Banner ();
  PawnHash = NULL;
  PawnHashSize = (1 << 16);
  memset ( (void*) ROOT_POSIZIONE0, 0, sizeof (typePOS));
  ROOT_POSIZIONE0->din_iniz =
    malloc (MAXIMUM_PLY * sizeof(typeDYNAMIC));
  ROOT_POSIZIONE0->DIN = ROOT_POSIZIONE0->din_iniz; 
  ROOT_POSIZIONE0->stop = FALSE;
  CPUS_SIZE = 1;
#ifdef YUSUF_MULTICORE
  rp_init ();
#endif
  InitPawnHash (2);
  InitHash (32);
  ResetHistory ();
  InitCaptureValus ();
  InitArrays ();
  InitPawns ();
  InitMaterialValue ();
  InitStatic ();
  NewGame (ROOT_POSIZIONE0, TRUE);
  MULTI_PV = 1;
  MULTI_CENTI_PAWN_PV = 65535;
#ifdef CON_ROBBO_BUILD
  total_iniz ();
#endif
  while (1)
    Input (ROOT_POSIZIONE0);
  return 0;
}
