#ifndef BUILD_next_move
#define BUILD_next_move
#include "RobboLito.h"

#include "next_move.c"
#include "white.h"
#else
#include "black.h"
#endif

#define RETURN(x) return(x)
uint32
MyNext (typePOS *POSITION, typeNEXT * PROSSIMO)
{
  typeMoveList *p, *q, *list;
  uint32 move, TEMP;
  switch (PROSSIMO->phase)
    {
    case TRANS:
      PROSSIMO->phase = CAPTURE_GEN;
      if (PROSSIMO->trans_move && MyOK (POSITION, PROSSIMO->trans_move))
	RETURN (PROSSIMO->trans_move);
    case CAPTURE_GEN:
      PROSSIMO->phase = CAPTURE_MOVES;
      PROSSIMO->move = 0;
      MyCapture (POSITION, PROSSIMO->LIST, OppOccupied);
    case CAPTURE_MOVES:
      while (1)
	{
	  p = PROSSIMO->LIST + PROSSIMO->move;
	  move = p->move;
	  if (!move)
	    break;
	  q = p + 1;
	  PROSSIMO->move++;
	  while (q->move)
	    {
	      if (move < q->move)
		{
		  TEMP = q->move;
		  q->move = move;
		  move = TEMP;
		}
	      q++;
	    }
	  if ((move & 0x7fff) == PROSSIMO->trans_move)
	    continue;
	  if (!EasySEE (move) && !MySEE (POSITION, move))
	    PROSSIMO->BAD_CAPS[PROSSIMO->bc++] = move;
	  else
	    break;
	}
      if (move)
	RETURN (move);
      PROSSIMO->phase = KILLER1;
      move = DYN->killer1;
      if (move && move != PROSSIMO->trans_move && POSITION->sq[TO (move)] == 0
	  && MyOK (POSITION, move))
	RETURN (move);
    case KILLER1:
      PROSSIMO->phase = KILLER2;
      move = DYN->killer2;
      if (move && move != PROSSIMO->trans_move && POSITION->sq[TO (move)] == 0
	  && MyOK (POSITION, move))
	RETURN (move);
    case KILLER2:
      PROSSIMO->phase = ORDINARY_MOVES;
      PROSSIMO->move = 0;
      list = MyOrdinary (POSITION, PROSSIMO->LIST);
      SortOrdinary (PROSSIMO->LIST, list, PROSSIMO->trans_move,
		       DYN->killer1, DYN->killer2);
    case ORDINARY_MOVES:
      move = (PROSSIMO->LIST + PROSSIMO->move)->move;
      PROSSIMO->move++;
      if (move)
	RETURN (move);
      PROSSIMO->phase = BAD_CAPS;
      PROSSIMO->BAD_CAPS[PROSSIMO->bc] = 0;
      PROSSIMO->move = 0;
    case BAD_CAPS:
      move = PROSSIMO->BAD_CAPS[PROSSIMO->move++];
      RETURN (move);
      /* */
    case TRANS2:
      PROSSIMO->phase = CAPTURE_PGEN2;
      if (PROSSIMO->trans_move && MyOK (POSITION, PROSSIMO->trans_move))
	RETURN (PROSSIMO->trans_move);
    case CAPTURE_PGEN2:
      PROSSIMO->phase = CAPTURE_MOVES2;
      PROSSIMO->move = 0;
      MyCapture (POSITION, PROSSIMO->LIST, PROSSIMO->TARGET);
    case CAPTURE_MOVES2:
      while (1)
	{
	  p = PROSSIMO->LIST + PROSSIMO->move;
	  move = p->move;
	  if (!move)
	    break;
	  q = p + 1;
	  PROSSIMO->move++;
	  while (q->move)
	    {
	      if (move < q->move)
		{
		  TEMP = q->move;
		  q->move = move;
		  move = TEMP;
		}
	      q++;
	    }
	  if ((move & 0x7fff) == PROSSIMO->trans_move)
	    continue;
	  else
	    break;
	}
      if (move)
	RETURN (move);
      PROSSIMO->move = 0;
      PROSSIMO->phase = QUIET_CHECKS;
      MyQuietChecks (POSITION, PROSSIMO->LIST, PROSSIMO->TARGET);
    case QUIET_CHECKS:
      move = (PROSSIMO->LIST + PROSSIMO->move)->move;
      PROSSIMO->move++;
      RETURN (move);
      /* */
    case EVADE_PHASE:
      move = (PROSSIMO->LIST + PROSSIMO->move)->move;
      PROSSIMO->move++;
      RETURN (move);
      /* */
    case TRANS3:
      PROSSIMO->phase = CAPTURE_GEN3;
      if (PROSSIMO->trans_move && MyOK (POSITION, PROSSIMO->trans_move))
	RETURN (PROSSIMO->trans_move);
    case CAPTURE_GEN3:
      PROSSIMO->phase = CAPTURE_MOVES3;
      PROSSIMO->move = 0;
      MyCapture (POSITION, PROSSIMO->LIST, OppOccupied);
    case CAPTURE_MOVES3:
      while (1)
	{
	  p = PROSSIMO->LIST + PROSSIMO->move;
	  move = p->move;
	  if (!move)
	    break;
	  q = p + 1;
	  PROSSIMO->move++;
	  while (q->move)
	    {
	      if (move < q->move)
		{
		  TEMP = q->move;
		  q->move = move;
		  move = TEMP;
		}
	      q++;
	    }
	  if ((move & 0x7fff) == PROSSIMO->trans_move)
	    continue;
	  else
	    break;
	}
      if (move)
	RETURN (move);
      PROSSIMO->move = 0;
      PROSSIMO->phase = QUIET_CHECKS3;
      MyQuietChecks (POSITION, PROSSIMO->LIST, OppOccupied);
    case QUIET_CHECKS3:
      move = (PROSSIMO->LIST + PROSSIMO->move)->move;
      PROSSIMO->move++;
      if (move)
	RETURN (move);
      PROSSIMO->move = 0;
      PROSSIMO->phase = POSITIONAL_GAIN_PHASE;
      MyPositionalGain (POSITION, PROSSIMO->LIST, PROSSIMO->mask);
    case POSITIONAL_GAIN_PHASE:
      move = (PROSSIMO->LIST + PROSSIMO->move)->move;
      PROSSIMO->move++;
      RETURN (move);
    case FASE_0:
      RETURN (0);
    }
  return 0;
}
