#ifndef BUILD_pv_node
#define BUILD_pv_node
#include "RobboLito.h"
#include "history.i"
#include "control.h"

#include "pv_node.c"
#include "white.h"
#else
#include "black.h"
#endif

#define RETURN(x) return(x)
int
MyPV (typePOS *POSITION, int ALPHA, int BETA, int depth, int check)
{
  typeNEXT PROSSIMO[1];
  typeHash *tr;
  int good_move, v, Value, k, i, trans_depth, move,
    move_depth = 0, trans_move = 0, hash_depth;
  typeMoveList *list, *p, *q;
  int EXT, best_value, new_depth, move_is_check, to, fr;
  typeDYNAMIC *POS0 = DYN;
  YUSUF128 H[1];
  int SINGULAR;
  boolean SPLIT;
  int SPLIT_ABISSO;

  if (BETA < -VALUE_MATE)
    RETURN (-VALUE_MATE);
  if (ALPHA > VALUE_MATE)
    RETURN (VALUE_MATE);
  if (depth <= 1)
    {
      if (check)
	return MyPVQsearchCheck (POSITION, ALPHA, BETA, 1);
      else
	return MyPVQsearch (POSITION, ALPHA, BETA, 1);
    }
  CheckRepetition;
  PROSSIMO->trans_move = 0;
  hash_depth = 0;
  PROSSIMO->move = 0;
  PROSSIMO->bc = 0;

  k = DYN->HASH & HashMask;
  (POS0 + 1)->move = 0;
  for (i = 0; i < 4; i++)
    {
      tr = HashTable + (k + i);
      HYATT_HASH();
      if ((tr->hash ^ (DYN->HASH >> 32)) == 0)
	{
	  trans_depth = tr->DepthLower;
	  move = tr->move;
	  if (move && trans_depth > move_depth)
	    {
	      move_depth = trans_depth;
	      (POS0 + 1)->move = trans_move = move;
	    }
	  if (tr->DepthLower > tr->DepthUpper)
	    {
	      trans_depth = tr->DepthLower;
	      Value = HashLowerBound (tr);
	    }
	  else
	    {
	      trans_depth = tr->DepthUpper;
	      Value = HashUpperBound (tr);
	    }
	  if (trans_depth > hash_depth)
	    hash_depth = trans_depth;
	  if (IsExact (tr) && trans_depth >= depth)
	    {
	      UPDATE_ANNI();
	      if (!ANALYSING)
		RETURN (Value);
	    }
	}
    }

  if (!trans_move && depth >= 6)
    {
      v = ALPHA;
      if (depth >= 10)
	{
	  v = MyPV (POSITION, ALPHA - depth, BETA + depth, depth - 8, check);
	  CHECK_HALT ();
	  if (v > ALPHA - depth)
	    trans_move = (POS0 + 1)->move;
	}
      if (v > ALPHA - depth)
	v = MyPV (POSITION, ALPHA - depth, BETA + depth, depth - 4, check);
      CHECK_HALT ();
      if (v > ALPHA - depth)
	trans_move = (POS0 + 1)->move;
    }
  else if (depth >= 10 && depth > hash_depth + 8)
    {
      v = MyPV (POSITION, ALPHA - depth, BETA + depth, depth - 8, check);
      CHECK_HALT ();
      if (v > ALPHA - depth)
	trans_move = (POS0 + 1)->move;
      if (v > ALPHA - depth)
	{
	  v = MyPV (POSITION, ALPHA - depth, BETA + depth, depth - 4, check);
	  CHECK_HALT ();
	  if (v > ALPHA - depth)
	    trans_move = (POS0 + 1)->move;
	}
    }

  PROSSIMO->trans_move = trans_move;
  PROSSIMO->phase = TRANS;
  EXT = 0;
  PROSSIMO->TARGET = OppOccupied;

  SINGULAR = 0;
  if (check)
    {
      list = MyEvasion (POSITION, PROSSIMO->LIST, 0xffffffffffffffff);
      PROSSIMO->phase = EVADE_PHASE;
      for (p = list - 1; p >= PROSSIMO->LIST; p--)
	{
	  if ((p->move & 0x7fff) == trans_move)
	    p->move |= 0xffff0000;
	  else if (p->move <= (0x80 << 24))
	    {
	      if ((p->move & 0x7fff) == POS0->killer1)
		p->move |= 0x7fff8000;
	      else if ((p->move & 0x7fff) == POS0->killer2)
		p->move |= 0x7fff0000;
	      else
		p->move |=
		  (p->move & 0x7fff) |
		  (HISTORY_VALUE (POSITION, p->move) << 15);
	    }
	  move = p->move;
	  for (q = p + 1; q < list; q++)
	    {
	      if (move < q->move)
		(q - 1)->move = q->move;
	      else
		break;
	    }
	  q--;
	  q->move = move;
	}
      if ((list - PROSSIMO->LIST) <= 1)
	SINGULAR = 2;
      if ((list - PROSSIMO->LIST) == 2)
	SINGULAR = 1;
      if ((list - PROSSIMO->LIST) > 2)
	SINGULAR = 0;
    }

  if (depth >= 16 && PROSSIMO->trans_move && SINGULAR < 2
      && MyOK (POSITION, PROSSIMO->trans_move))
    {
      move = PROSSIMO->trans_move;
      to = TO (move);
      fr = FROM (move);
      MAKE (POSITION, move);
      EVAL (move);
      if (ILLEGAL_MOVE)
	{
	  UNDO (POSITION, move);
	  goto SKIP;
	}
      Value = -OppPV (POSITION, -BETA, -ALPHA, depth - 10, (MOVE_IS_CHECK) != 0);
      UNDO (POSITION, move);
      CHECK_HALT ();
      if (check)
	v =
	  MyExcludeCheck (POSITION, Value - depth / 2,
			      depth - MIN (12, depth / 2), move & 0x7fff);
      else
	v =
	  MyExclude (POSITION, Value - depth / 2,
		       depth - MIN (12, depth / 2), move & 0x7fff);
      CHECK_HALT ();
      if (v < Value - depth / 2)
	{
	  SINGULAR = 1;
	  if (check)
	    v =
	      MyExcludeCheck (POSITION, Value - depth,
				  depth - MIN (12, depth / 2), move & 0x7fff);
	  else
	    v =
	      MyExclude (POSITION, Value - depth,
			   depth - MIN (12, depth / 2), move & 0x7fff);
	  CHECK_HALT ();
	  if (v < Value - depth)
	    SINGULAR = 2;
	}
    }
 SKIP:
  best_value = -VALUE_INFINITY;
  PROSSIMO->move = 0;
  PROSSIMO->bc = 0;
  good_move = 0;

  SPLIT = FALSE;
  SPLIT_ABISSO = 14;
  while (TRUE)
    {
#if 1 && defined (YUSUF_MULTICORE) /* nein check ? */ /* depth ya 10 ? */
      /* Personal Opinion: with the *increase* for the depth ! */
      /* now what is the best? decembrist testing for best params to find it! */
      if (TITANIC_MODE && SMP_FREE != 0 && !check &&
	  depth >= SPLIT_ABISSO && !SPLIT && best_value != -VALUE_INFINITY)
	{
          int r;
	  boolean b;
          SPLIT = TRUE;
          b = IVAN_SPLIT (POSITION, PROSSIMO, depth, BETA, ALPHA, NODE_TYPE_PV, &r);
	  CHECK_HALT ();
	  if (b)
	    {
	      if (r > ALPHA || !good_move)
		return r;
	      move = good_move; /* SMP PV */
	      (POS0 + 1)->move = good_move & 0x7fff;
	      best_value = r;
	      goto IVAN;
	    }
        }
#endif
      move = MyNext (POSITION, PROSSIMO);
      if (!move)
	break;
      to = TO (move);
      fr = FROM (move);
      if (ALPHA > 0 && POS0->reversible >= 2
	  && ((TO (move) << 6) | FROM (move)) == (POS0 - 1)->move
	  && POSITION->sq[TO (move)] == 0)
	{
	  best_value = MAX (0, best_value);
	  continue;
	}
      move &= 0x7fff;
      MAKE (POSITION, move);
      EVAL (move);
      if (ILLEGAL_MOVE)
	{
	  UNDO (POSITION, move);
	  continue;
	}
      move_is_check = (MOVE_IS_CHECK != 0);
      /* LMR ? */
      EXT = 0;
      if (EXT < 2)
	{
	  if (PassedPawnPush (to, SIXTH_RANK (to)))
	    EXT = 2;
	}
      if (EXT < 2)
	{
	  if (POS1->cp != 0 || move_is_check
	      || (check && EARLY_GAME))
	    EXT = 1;
	  else if (PassedPawnPush (to, FOURTH_RANK (to)))
	    EXT = 1;
	}
      if (PROSSIMO->trans_move != move)
	SINGULAR = 0;
      new_depth = depth - 2 + MAX (EXT, SINGULAR);

      if (PROSSIMO->trans_move != move && new_depth > 1)
	{
	  if (new_depth <= 7)
	    {
	      if (move_is_check)
		v = -OppLowDepthCheck (POSITION, -ALPHA, new_depth);
	      else
		v = -OppLowDepth (POSITION, -ALPHA, new_depth);
	    }
	  else
	    {
	      if (move_is_check)
		v = -OppCutCheck (POSITION, -ALPHA, new_depth);
	      else
		v = -OppCut (POSITION, -ALPHA, new_depth);
	    }
	  if (v > ALPHA)
	    v = -OppPV (POSITION, -BETA, -ALPHA, new_depth, move_is_check);
	}
      else
	v = -OppPV (POSITION, -BETA, -ALPHA, new_depth, move_is_check);
      UNDO (POSITION, move);
      CHECK_HALT ();
	  
      if (v <= ALPHA && POSITION->sq[TO (move)] == 0 && MoveHistory (move))
	HISTORY_BAD1 (move, depth);
      if (v <= best_value)
	continue;
      best_value = v;
      if (v <= ALPHA)
	continue;
      ALPHA = v;
      good_move = move;
      HashLower (DYN->HASH, move, depth, v);
      if (v >= BETA)
	{
	  if (POSITION->sq[TO (move)] == 0 && MoveHistory (move))
	    HISTORY_GOOD (move, depth);
	  RETURN (v);
	}
    }

  move = good_move;
  (POS0 + 1)->move = good_move & 0x7fff;
  if (best_value == -VALUE_INFINITY) /* con SMP ? */
    {
      if (!check)
	RETURN (0);
      RETURN (HEIGHT (POSITION) - VALUE_MATE);
    }
 IVAN:
  if (move)
    {
      if (POSITION->sq[TO (move)] == 0 && MoveHistory (move))
	HISTORY_GOOD (move, depth);
      HashExact (POSITION, move, depth, best_value, FLAG_EXACT);
      RETURN (best_value);
    }
  HashUpper (DYN->HASH, depth, best_value);
  RETURN (best_value);
}
