#ifndef BUILD_root_analysis
#define BUILD_root_analysis
#include "RobboLito.h"
#define RETURN(x) return(x)

#include "control.h"
typeMoveList ROOT_MOVE_LIST[256];
#include "root_analysis.c"
#include "white.h"
#else
#include "black.h"
#endif

int
MyAnalysis (typePOS *POSITION, int ALPHA, int BETA, int depth)
{
  int CNT, origALPHA, best_value, cnt,
    move_is_check, new_depth, v, TEMPvalu;
  typeMoveList *p, *q;
  typeDYNAMIC *POS0 = DYN;
  uint32 move;
  int EXT;
  int to;

  if (MULTI_PV != 1)
    return MyMultiPV (POSITION, depth);
  if (BETA > VALUE_MATE)
    BETA = VALUE_MATE;
  if (ALPHA < -VALUE_MATE)
    ALPHA = -VALUE_MATE;
  SEND ("info depth %d\n", depth / 2);
  CNT = 0;
  for (p = ROOT_MOVE_LIST; p->move; p++)
    {
      CNT++;
      p->move &= 0x7fff;
    }
  origALPHA = ALPHA;
  p = ROOT_MOVE_LIST;
  v = best_value = -VALUE_INFINITY;
  cnt = 0; /* SMP ? */
  while ((move = p->move))
    {
      MAKE (POSITION, move);
      EVAL (move);
      move_is_check = (MOVE_IS_CHECK != 0);
      EXT =0;
      to = TO (move);
      if (POS1->cp || move_is_check ||
	  PassedPawnPush (to, FOURTH_RANK (to)))
	EXT = 1;
      new_depth = depth - 2 + EXT;
      if (ANALYSING && depth >= 24)
	SEND ("info currmove %s currmovenumber %d\n",
		      Notate (move, STRING1),
		      (p - ROOT_MOVE_LIST) + 1);
      if (best_value == -VALUE_INFINITY || depth <= 2)
	v = -OppPV (POSITION, -BETA, -ALPHA, new_depth, move_is_check);
      else
	{
	  if (new_depth <= 7)
	    {
	      if (move_is_check)
		v = -OppLowDepthCheck (POSITION, -ALPHA, new_depth);
	      else
		v = -OppLowDepth (POSITION, -ALPHA, new_depth);
	    }
	  else
	    {
	      if (new_depth >= 16 && ANALYSING) /* ANALYSING es TRUE */
		{
		  int an = new_depth - 12;
		  v = VALUE_INFINITY;
		  while (an <= new_depth && v > ALPHA)
		    {
		      v = -OppPV (POSITION, -ALPHA - 1, -ALPHA, an, move_is_check);
		      an += 4;
		    }
		  if (an > new_depth)
		      goto DEC;
		}
	      if (move_is_check)
		v = -OppCutCheck (POSITION, -ALPHA, new_depth);
	      else
		v = -OppCut (POSITION, -ALPHA, new_depth);
	    }
	  if (v > ALPHA)
	    v = -OppPV (POSITION, -ALPHA - 1, -ALPHA, new_depth, move_is_check);
	DEC:
	  if (v > ALPHA)
	    v = -OppPV (POSITION, -BETA, -ALPHA, new_depth, move_is_check);
	  if (v <= ALPHA)
	    v = ALPHA;
	} /* NORMALE */
      UNDO (POSITION, move);
      CHECK_HALT ();
      if (v <= ALPHA)
	TEMPvalu = origALPHA;
      else
	TEMPvalu = v;
      p->move |= (TEMPvalu + 0x8000) << 16;
      if (v > best_value)
	{
	  best_value = v;
	  if (best_value == -VALUE_INFINITY || v > ALPHA)
	    {
	      ROOT_BEST_MOVE = move;
	      ROOT_SCORE = v;
	      ROOT_DEPTH = depth;
	      if (v > ALPHA && v < BETA)
		Information (POSITION, GetClock () - START_CLOCK, origALPHA, v, BETA);
	    }
	}
      if (v > ALPHA)
	ALPHA = v;
      cnt++;
      if (v < BETA)
	{
	  p++;
	  continue;
	}
      break;
    }
  for (p = ROOT_MOVE_LIST + (CNT - 1); p >= ROOT_MOVE_LIST; p--)
    {
      move = p->move;
      for (q = p + 1; q < ROOT_MOVE_LIST + CNT; q++)
	{
	  if ((move & 0xffff0000) < (q->move & 0xffff0000))
	    (q - 1)->move = q->move;
	  else
	    break;
	}
      q--;
      q->move = move;
    }
  ROOT_DEPTH = depth;
  Information (POSITION, GetClock () - START_CLOCK, origALPHA, best_value, BETA);
  return best_value;
}
