#include "RobboLito.h"

#include "control.h"
#include "null_move.i"
#include <string.h>

#define LEGAL (POSITION->wtm ? !BLACK_IN_CHECK : !WHITE_IN_CHECK)
#define IN_CHECK (POSITION->wtm ? WHITE_IN_CHECK: BLACK_IN_CHECK)
//
jmp_buf J;
//
void
OutputBestMove (typePOS *POSITION)
{
  int i, k;
  typePVHash* tr;
  int PONDER_MOVE = MOVE_NONE;
  if (!ROOT_BEST_MOVE)
    {
      SEND ("bestmove NULL\n");
      return;
    }
  Make (POSITION, ROOT_BEST_MOVE);
  EVAL (0);
#if 0
  SEND ("hash %lld\n", POSITION->DIN->HASH); /* %llx ? */
#endif
#if 1
  k = DYN->HASH & PVHashMask;
  for (i = 0; i < 4; i++)
    {
      tr = PVHashTable + (k + i);
      HYATT_HASH();
      if (tr->hash == DYN->HASH)
	{
	  PONDER_MOVE = tr->move;
	  break;
	}
    }
  if ((POSITION->wtm ?
       !WhiteOK (POSITION, PONDER_MOVE) :
       !BlackOK (POSITION, PONDER_MOVE)))
    PONDER_MOVE = MOVE_NONE;
  else
    {
      Make (POSITION, PONDER_MOVE);
      EVAL (0);
      if (!POSITION->wtm ?
	  (wBitboardK & DYN->Batt) :
	  (bBitboardK & DYN->wAtt))
	PONDER_MOVE = MOVE_NONE;
      Undo (POSITION, PONDER_MOVE);
    }
#endif
  Undo (POSITION, ROOT_BEST_MOVE);
  SEND ("bestmove %s ponder %s\n",
		Notate (ROOT_BEST_MOVE, STRING1),
		Notate (PONDER_MOVE, STRING2));
}

static char *
MODIFIER (int ALPHA, int Value, int BETA, char *s)
{
  s[0] = 0;
  if (Value <= ALPHA)
    strcpy (s, "upperbound");
  else if (Value >= BETA)
    strcpy (s, "lowerbound");
  else
    strcpy (s, "score");
  return s;
}

static char *
cp_mate (int Value, char *s)
{
  if (Value > VALUE_MATE - MAXIMUM_PLY)
    sprintf (s, "mate %d", (VALUE_MATE + 1 - Value) / 2);
  else if (Value < -VALUE_MATE + MAXIMUM_PLY)
    sprintf (s, "mate %d", (-VALUE_MATE - Value) / 2);
  else
    sprintf (s, "cp %d", Value);
  return s;
}

void
Information (typePOS *POSITION, sint64 x, int ALPHA, int Value, int BETA)
{
  uint64 t, nps, NODES = 0;
  int cpu, rp;
  int sd, k, move;
  typeDYNAMIC *p;
  char pv[256 * 6], *q;
  typePVHash *tr;
  typeHash *tz;
  uint64 HashStack[256];
  int i;
  int cnt = 0;
  boolean B;
  YUSUF128 H[1];
  int mpv;
  if (TITANIC_MODE)
    for (cpu = 0; cpu < CPUS_SIZE; cpu++)
      for (rp = 0; rp < RP_PER_CPU ; rp++)
	NODES += ROOT_POSITION[cpu][rp].nodes;
  else
    NODES = ROOT_POSIZIONE0->nodes;
#if 0
  for (p = DYNAMIC_ROOT + 1; p->HASH; p++);
  sd = p - (DYNAMIC_ROOT + 1);
#else
  sd = 0;
#endif
  memset (HashStack, 0, 256 * sizeof (uint64));
  t = x / 1000;
  if (t == 0)
    nps = 0;
  else
    nps = NODES / t;
  if (MULTI_PV == 1)
    MPV[0].move = ROOT_BEST_MOVE;
  if (MULTI_PV == 1)
    MPV[0].Value = Value;
  for (mpv = 0; mpv < MULTI_PV; mpv++)
    {
      move = MPV[mpv].move;
      if (move == MOVE_NONE) 
	break;
      q = pv;
      cnt = 0;
      HashStack[cnt++] = DYN->HASH;
      Notate (move, STRING1);
      strcpy (q, STRING1);
      q += strlen (STRING1);
      strcpy (q, " ");
      q++;  
      while (move)
	{
	  Make (POSITION, move);
	  EVAL (0);
	  B = FALSE;
	  for (i = 0; i < cnt; i++)
	    if (HashStack[i] == DYN->HASH)
	      B = TRUE;
	  if (B)
	    break;
	  HashStack[cnt++] = DYN->HASH;
	  move = 0;
	  k = DYN->HASH & PVHashMask;
	  for (i = 0; i < 4; i++)
	    {
	      tr = PVHashTable + (k + i);
	      HYATT_HASH();
	      if (tr->hash == DYN->HASH)
		{
		  move = tr->move;
		  break;
		}
	    }
#if 1
	  if (!move)
	    {      
	      k = DYN->HASH & HashMask;
	      for (i = 0; i < 4; i++)
		{
		  tz = HashTable + (k + i);
		  HYATT_HASH();
		  if (tz->hash == DYN->HASH)
		    {
		      move = tz->move;
		      break;
		    }
		}
	    }
#endif
	  if (!move
	      || (POSITION->wtm ?
		  !WhiteOK (POSITION, move) :
		  !BlackOK (POSITION, move)))
	    break;
	  if (cnt > 250)
	    break;
	  Notate (move, STRING1);
	  strcpy (q, STRING1);
	  q += strlen (STRING1);
	  strcpy (q, " ");
	  q++;
	}
      q--;
      *q = 0;
      while (DYN != (DYNAMIC_ROOT + 1))
	{
	  if (!DYN->move)
	    UndoNull (POSITION);
	  else
	    Undo (POSITION, DYN->move);
	}
      SEND
	("info multipv %d time %lld nodes %lld nps %lld %s %s depth %d pv %s\n",
	 mpv + 1, t, NODES, nps * 1000,
	 MODIFIER (ALPHA, MPV[mpv].Value, BETA, STRING3),
	 cp_mate (MPV[mpv].Value, STRING2), ROOT_DEPTH / 2, pv);
    }
}

#include <string.h>
void
Search (typePOS *POSITION)
{
  int z, i;
  typeDYNAMIC *p, *q;
  typePOS* POS;
  NEW_GAME = FALSE;
  START_CLOCK = GetClock ();
  INIT_CLOCK = clock ();
  PONDER_HIT = FALSE;
  StackHeight = -1;
  ROOT_BEST_MOVE = ROOT_DEPTH = ROOT_SCORE = 0;
  for (p = DYNAMIC_ROOT; p <= DYN; p++)
    STACK[++StackHeight] = p->HASH;
  NODE_CHECK = 0;
  ROOT_POSIZIONE0->nodes = 0;
  if (ANALYSING)
    {
      boolean RIPETIZIONE;
      for (p = DYNAMIC_ROOT; p < DYN; p++)
	{
	  RIPETIZIONE = FALSE;
	  for (q = p + 2; q < DYN; q += 2)
	    if (p->HASH == q->HASH)
	      {
		RIPETIZIONE = TRUE;
		break;
	      }
	  if (!RIPETIZIONE)
	    STACK[p - DYNAMIC_ROOT] = 0;
	  (p + 1)->move = 0;
	}
    }
  memcpy (DYNAMIC_ROOT + 1, DYN, sizeof (typeDYNAMIC));
  memset (DYNAMIC_ROOT + 2, 0, 254 * sizeof (typeDYNAMIC));
  memset (DYNAMIC_ROOT, 0, sizeof (typeDYNAMIC));
  DYN = DYNAMIC_ROOT + 1;
  POSITION->height = 0;
  IncrementAge ();
#ifdef CON_ROBBO_BUILD
  if (RobboFare (POSITION)) return;
#endif
  ROOT_PREVIOUS = -VALUE_MATE;
  EASY_MOVE = FALSE;
  JUMP_IS_SET = TRUE;
  POS = POSITION;
#ifdef YUSUF_MULTICORE
  if (TITANIC_MODE)
    {
      ivan_init_smp();
      POS = &ROOT_POSITION[0][0];
    }
#endif
  z = setjmp (J);
  if (!z)
    {
      if (POS->wtm)
	TopWhite (POS);
      else
	TopBlack (POS);
    }
#ifdef YUSUF_MULTICORE
  if (TITANIC_MODE)
    ivan_end_smp();
#endif
  JUMP_IS_SET = FALSE;
  PREVIOUS_DEPTH = ROOT_DEPTH;
  if (POS == POSITION)
    {
      while (POS->DIN != (POS->din_iniz + 1))
	{
	  if (!POS->DIN->move)
	    UndoNull (POS);
	  else
	    Undo (POS, POS->DIN->move);
	}
    }
  Information (POSITION, GetClock () - START_CLOCK, -32767, ROOT_SCORE, 32767);
  if (DO_INFINITE && !STOP)
    {
      SEND ("Idle with go infinite\n");
      while (!STOP)
	Input (POSITION);      
    }
#if 1
  if (DO_PONDER && !STOP && !PONDER_HIT)
    {
      SEND ("Idle with go ponder\n");
      while (!STOP && !PONDER_HIT)
	Input (POSITION);
    }
#endif
  OutputBestMove (POSITION);
}
