#ifndef BUILD_top_node
#define BUILD_top_node
#include "RobboLito.h"

#include "control.h"
#define IsCheck  ( POSITION->wtm ?    (wBitboardK & DYN->Batt) :    (bBitboardK & DYN->wAtt) )

typeMoveList ROOT_MOVE_LIST[256];
#include "top_node.c"
#include "white.h"
#else
#include "black.h"
#endif

void
MyTop (typePOS *POSITION)
{
  int i, k, depth, A, L, U, v, Value = 0, trans_depth,
    move_depth = 0, EXACT_DEPTH = 0;
  uint32 move, HASH_MOVE = 0, EXACT_MOVE = 0, to, fr;
  typeMoveList *p, *q, *list;
  typeHash *tr;
  typeDYNAMIC *POS0 = DYN;
  int PieceValue[16] = { 0, 1, 3, 0, 3, 3, 5, 9, 0, 1, 3, 0, 3, 3, 5, 9 };
  YUSUF128 H[1];

  if (ANALYSING)
    {
      MyTopAnalysis (POSITION);
      return;
    }
  EVAL (0);
  if (IsCheck)
    list = MyEvasion (POSITION, ROOT_MOVE_LIST, 0xffffffffffffffff);
  else
    {
      q = MyCapture (POSITION, ROOT_MOVE_LIST, OppOccupied);
      list = MyOrdinary (POSITION, q);
      SortOrdinary (list, q, 0, 0, 0);
    }

  k = DYN->HASH & HashMask;
  for (i = 0; i < 4; i++)
    {
      tr = HashTable + (k + i);
      HYATT_HASH();
      if ((tr->hash ^ (DYN->HASH >> 32)) == 0)
	{
	  trans_depth = tr->DepthLower;
	  move = tr->move;
	  if (IsExact (tr))
	    {
	      EXACT_DEPTH = trans_depth;
	      EXACT_MOVE = move;
	      Value = HashUpperBound (tr);
	    }
	  if (move && trans_depth > move_depth)
	    {
	      move_depth = trans_depth;
	      HASH_MOVE = move;
	    }
	}
    }

  if (EXACT_DEPTH >= PREVIOUS_DEPTH - 6 && EXACT_MOVE == HASH_MOVE
      && EXACT_MOVE && PREVIOUS_FAST && PREVIOUS_DEPTH >= 18
      && MyOK (POSITION, EXACT_MOVE) && Value < 25000 && Value > -25000
      && !ANALYSING)
    {
      ROOT_SCORE = Value;
      ROOT_BEST_MOVE = EXACT_MOVE;
      ROOT_DEPTH = EXACT_DEPTH;
      PREVIOUS_FAST = FALSE;
      if (!IsCheck)
	v = MyExclude (POSITION, Value - 50, PREVIOUS_DEPTH - 6, EXACT_MOVE);
      else
	v =
	  MyExcludeCheck (POSITION, Value - 50, PREVIOUS_DEPTH - 6,
			      EXACT_MOVE);
      if (v < Value - 50)
	return;
    }

  PREVIOUS_FAST = TRUE;
  q = ROOT_MOVE_LIST;
  for (p = ROOT_MOVE_LIST; p < list; p++)
    {
      move = p->move & 0x7fff;
      MAKE (POSITION, move);
      EVAL (0);
      if (ILLEGAL_MOVE)
	{
	  UNDO (POSITION, move);
	  continue;
	}      
      else
	(q++)->move = move & 0x7fff;
      UNDO (POSITION, move);
    }
  q->move = 0;
  list = q;

  for (p = ROOT_MOVE_LIST; p < list; p++)
    {
      if (POSITION->sq[TO (p->move)])
	{
	  to = POSITION->sq[TO (p->move)];
	  fr = POSITION->sq[FROM (p->move)];
	  p->move |=
	    0xff000000 + ((16 * PieceValue[to] - PieceValue[fr]) << 16);
	}
    }
  for (p = ROOT_MOVE_LIST; p < list; p++)
    if (p->move == HASH_MOVE)
      p->move |= 0xffff0000;
  for (p = list - 1; p >= ROOT_MOVE_LIST; p--)
    {
      move = p->move;
      for (q = p + 1; q < list; q++)
	{
	  if (move < q->move)
	    (q - 1)->move = q->move;
	  else
	    break;
	}
      q--;
      q->move = move;
    }

  L = -VALUE_MATE;
  U = VALUE_MATE;
  if (!ROOT_MOVE_LIST[0].move)
    {
      if (IsCheck)
	{
	  ROOT_SCORE = L;
	}
      else
	{
	  ROOT_SCORE = 0;
	}
      ROOT_BEST_MOVE = 0;
      ROOT_DEPTH = 0;
      return;
    }
  for (depth = 2; depth <= 250; depth += 2)
    {
      BAD_MOVE = FALSE;
      BATTLE_MOVE = FALSE;
      if (depth >= 14 && ROOT_SCORE <= 25000 && -25000 <= ROOT_SCORE)
	{
	  A = 8;
	  L = ROOT_SCORE - A;
	  U = ROOT_SCORE + A;
	  if (L < -25000)
	    L = -VALUE_MATE;
	  if (U > 25000)
	    U = VALUE_MATE;
	AGAIN:
	  v = MyRootNode (POSITION, L, U, depth);
	  if (v > L && v < U)
	    goto CHECK_DONE;
	  if (v <= L)
	    {
	      L -= A;
	      A += A / 2;
	      ROOT_SCORE = L;
	      goto AGAIN;
	    }
	  else
	    {
	      U += A;
	      A += A / 2;
	      ROOT_SCORE = U;
	      goto AGAIN;
	    }
	}
      else
	v = MyRootNode (POSITION, -VALUE_MATE, VALUE_MATE, depth);
    CHECK_DONE:
      if (depth == 2)
	{
	  if (!ROOT_MOVE_LIST[1].move
	      || (ROOT_MOVE_LIST[0].move - ROOT_MOVE_LIST[1].move >=
		  (200 << 16)))
	    EASY_MOVE = TRUE;
	}
      ROOT_PREVIOUS = ROOT_SCORE;
      CheckDone (POSITION, depth / 2);
    }
}
