// 64 bit version (bits operations):
#ifdef _MSC_VER
static int BSF( UINT64 x )
{
	int y;
	_BitScanForward64(&y, x);
	return y;
    }
static int BSR( UINT64 x )
{
	int y;
	_BitScanReverse64(&y, x);
	return y;
}
#else
static int BSF( UINT64 x )
{
	_asm
	{
		bsf rax, x
	}
}
static int BSR( UINT64 x )
{
	_asm
	{
		bsr rax, x
	}
}
#endif

#ifdef HAS_POPCNT
static int
POPCNT (UINT64 x)
{
 /* _asm
    {
      bsr popcnt, x
    } 
 */
 return __popcnt64(x);
}
#else /* no POPCNT */
static INLINE int
POPCNT (uint64 w)
{
  w = w - ((w >> 1) & 0x5555555555555555ULL);
  w = (w & 0x3333333333333333ULL) + ((w >> 2) & 0x3333333333333333ULL);
  w = (w + (w >> 4)) & 0x0f0f0f0f0f0f0f0fULL;
  return (w * 0x0101010101010101ull) >> 56;
}
#endif /* HAS_POPCNT */
